/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#pragma once

#include "AnimationEvent.h"
#include "JSDOMConvert.h"
#include "JSEvent.h"

namespace WebCore {

class JSAnimationEvent : public JSEvent {
public:
    using Base = JSEvent;
    using DOMWrapped = AnimationEvent;
    static JSAnimationEvent* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, Ref<AnimationEvent>&& impl)
    {
        JSAnimationEvent* ptr = new (NotNull, JSC::allocateCell<JSAnimationEvent>(globalObject->vm().heap)) JSAnimationEvent(structure, *globalObject, WTFMove(impl));
        ptr->finishCreation(globalObject->vm());
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::VM&, JSC::JSGlobalObject*);
    static JSC::JSObject* prototype(JSC::VM&, JSC::JSGlobalObject*);

    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::JSType(JSEventType), StructureFlags), info());
    }

    static JSC::JSValue getConstructor(JSC::VM&, const JSC::JSGlobalObject*);
    AnimationEvent& wrapped() const
    {
        return static_cast<AnimationEvent&>(Base::wrapped());
    }
protected:
    JSAnimationEvent(JSC::Structure*, JSDOMGlobalObject&, Ref<AnimationEvent>&&);

    void finishCreation(JSC::VM&);
};

JSC::JSValue toJS(JSC::ExecState*, JSDOMGlobalObject*, AnimationEvent&);
inline JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, AnimationEvent* impl) { return impl ? toJS(state, globalObject, *impl) : JSC::jsNull(); }
JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject*, Ref<AnimationEvent>&&);
inline JSC::JSValue toJSNewlyCreated(JSC::ExecState* state, JSDOMGlobalObject* globalObject, RefPtr<AnimationEvent>&& impl) { return impl ? toJSNewlyCreated(state, globalObject, impl.releaseNonNull()) : JSC::jsNull(); }

template<> struct JSDOMWrapperConverterTraits<AnimationEvent> {
    using WrapperClass = JSAnimationEvent;
    using ToWrappedReturnType = AnimationEvent*;
};
template<> AnimationEvent::Init convertDictionary<AnimationEvent::Init>(JSC::ExecState&, JSC::JSValue);


} // namespace WebCore
