/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSBlobPropertyBag.h"

#include "JSBlobLineEndings.h"

using namespace JSC;

namespace WebCore {

template<> BlobPropertyBag convertDictionary<BlobPropertyBag>(ExecState& state, JSValue value)
{
    VM& vm = state.vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&state, throwScope);
        return { };
    }
    if (UNLIKELY(object && object->type() == RegExpObjectType)) {
        throwTypeError(&state, throwScope);
        return { };
    }
    BlobPropertyBag result;
    JSValue endingsValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "endings"));
    if (!endingsValue.isUndefined()) {
        result.endings = convert<IDLEnumeration<BlobLineEndings>>(state, endingsValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.endings = BlobLineEndings::Transparent;
    JSValue typeValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "type"));
    if (!typeValue.isUndefined()) {
        result.type = convert<IDLDOMString>(state, typeValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.type = emptyString();
    return result;
}

} // namespace WebCore
