/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSCSSNamespaceRule.h"

#include "JSDOMBinding.h"
#include "JSDOMBindingCaller.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMConvert.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMWrapperCache.h"
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

// Attributes

JSC::EncodedJSValue jsCSSNamespaceRuleNamespaceURI(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsCSSNamespaceRulePrefix(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsCSSNamespaceRuleConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSCSSNamespaceRuleConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);

class JSCSSNamespaceRulePrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSCSSNamespaceRulePrototype* create(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSCSSNamespaceRulePrototype* ptr = new (NotNull, JSC::allocateCell<JSCSSNamespaceRulePrototype>(vm.heap)) JSCSSNamespaceRulePrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSCSSNamespaceRulePrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSCSSNamespaceRuleConstructor = JSDOMConstructorNotConstructable<JSCSSNamespaceRule>;

template<> JSValue JSCSSNamespaceRuleConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    return JSCSSRule::getConstructor(vm, &globalObject);
}

template<> void JSCSSNamespaceRuleConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSCSSNamespaceRule::prototype(vm, &globalObject), DontDelete | ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(&vm, String(ASCIILiteral("CSSNamespaceRule"))), ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), ReadOnly | DontEnum);
}

template<> const ClassInfo JSCSSNamespaceRuleConstructor::s_info = { "CSSNamespaceRule", &Base::s_info, 0, CREATE_METHOD_TABLE(JSCSSNamespaceRuleConstructor) };

/* Hash table for prototype */

static const HashTableValue JSCSSNamespaceRulePrototypeTableValues[] =
{
    { "constructor", DontEnum, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSNamespaceRuleConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCSSNamespaceRuleConstructor) } },
    { "namespaceURI", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSNamespaceRuleNamespaceURI), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "prefix", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSNamespaceRulePrefix), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
};

const ClassInfo JSCSSNamespaceRulePrototype::s_info = { "CSSNamespaceRulePrototype", &Base::s_info, 0, CREATE_METHOD_TABLE(JSCSSNamespaceRulePrototype) };

void JSCSSNamespaceRulePrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSCSSNamespaceRulePrototypeTableValues, *this);
}

const ClassInfo JSCSSNamespaceRule::s_info = { "CSSNamespaceRule", &Base::s_info, 0, CREATE_METHOD_TABLE(JSCSSNamespaceRule) };

JSCSSNamespaceRule::JSCSSNamespaceRule(Structure* structure, JSDOMGlobalObject& globalObject, Ref<CSSNamespaceRule>&& impl)
    : JSCSSRule(structure, globalObject, WTFMove(impl))
{
}

void JSCSSNamespaceRule::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSCSSNamespaceRule::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSCSSNamespaceRulePrototype::create(vm, globalObject, JSCSSNamespaceRulePrototype::createStructure(vm, globalObject, JSCSSRule::prototype(vm, globalObject)));
}

JSObject* JSCSSNamespaceRule::prototype(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSCSSNamespaceRule>(vm, globalObject);
}

template<> inline JSCSSNamespaceRule* BindingCaller<JSCSSNamespaceRule>::castForAttribute(ExecState& state, EncodedJSValue thisValue)
{
    return jsDynamicDowncast<JSCSSNamespaceRule*>(state.vm(), JSValue::decode(thisValue));
}

static inline JSValue jsCSSNamespaceRuleNamespaceURIGetter(ExecState&, JSCSSNamespaceRule&, ThrowScope& throwScope);

EncodedJSValue jsCSSNamespaceRuleNamespaceURI(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSCSSNamespaceRule>::attribute<jsCSSNamespaceRuleNamespaceURIGetter>(state, thisValue, "namespaceURI");
}

static inline JSValue jsCSSNamespaceRuleNamespaceURIGetter(ExecState& state, JSCSSNamespaceRule& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLDOMString>(state, impl.namespaceURI());
    return result;
}

static inline JSValue jsCSSNamespaceRulePrefixGetter(ExecState&, JSCSSNamespaceRule&, ThrowScope& throwScope);

EncodedJSValue jsCSSNamespaceRulePrefix(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSCSSNamespaceRule>::attribute<jsCSSNamespaceRulePrefixGetter>(state, thisValue, "prefix");
}

static inline JSValue jsCSSNamespaceRulePrefixGetter(ExecState& state, JSCSSNamespaceRule& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLDOMString>(state, impl.prefix());
    return result;
}

EncodedJSValue jsCSSNamespaceRuleConstructor(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    JSCSSNamespaceRulePrototype* domObject = jsDynamicDowncast<JSCSSNamespaceRulePrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!domObject))
        return throwVMTypeError(state, throwScope);
    return JSValue::encode(JSCSSNamespaceRule::getConstructor(state->vm(), domObject->globalObject()));
}

bool setJSCSSNamespaceRuleConstructor(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    JSValue value = JSValue::decode(encodedValue);
    JSCSSNamespaceRulePrototype* domObject = jsDynamicDowncast<JSCSSNamespaceRulePrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!domObject)) {
        throwVMTypeError(state, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return domObject->putDirect(state->vm(), state->propertyNames().constructor, value);
}

JSValue JSCSSNamespaceRule::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSCSSNamespaceRuleConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}


}
