/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#pragma once

#include "CanvasRenderingContext2D.h"
#include "JSDOMConvert.h"
#include "JSDOMWrapper.h"
#include <wtf/NeverDestroyed.h>

namespace WebCore {

class JSCanvasRenderingContext2D : public JSDOMWrapper<CanvasRenderingContext2D> {
public:
    using Base = JSDOMWrapper<CanvasRenderingContext2D>;
    static JSCanvasRenderingContext2D* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, Ref<CanvasRenderingContext2D>&& impl)
    {
        JSCanvasRenderingContext2D* ptr = new (NotNull, JSC::allocateCell<JSCanvasRenderingContext2D>(globalObject->vm().heap)) JSCanvasRenderingContext2D(structure, *globalObject, WTFMove(impl));
        ptr->finishCreation(globalObject->vm());
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::VM&, JSC::JSGlobalObject*);
    static JSC::JSObject* prototype(JSC::VM&, JSC::JSGlobalObject*);
    static CanvasRenderingContext2D* toWrapped(JSC::VM&, JSC::JSValue);
    static void destroy(JSC::JSCell*);

    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

    static JSC::JSValue getConstructor(JSC::VM&, const JSC::JSGlobalObject*);
    static void visitChildren(JSCell*, JSC::SlotVisitor&);
    void visitAdditionalChildren(JSC::SlotVisitor&);

    static void visitOutputConstraints(JSCell*, JSC::SlotVisitor&);
    template<typename> static JSC::Subspace* subspaceFor(JSC::VM& vm) { return outputConstraintSubspaceFor(vm); }
protected:
    JSCanvasRenderingContext2D(JSC::Structure*, JSDOMGlobalObject&, Ref<CanvasRenderingContext2D>&&);

    void finishCreation(JSC::VM&);
};

class JSCanvasRenderingContext2DOwner : public JSC::WeakHandleOwner {
public:
    virtual bool isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown>, void* context, JSC::SlotVisitor&);
    virtual void finalize(JSC::Handle<JSC::Unknown>, void* context);
};

inline JSC::WeakHandleOwner* wrapperOwner(DOMWrapperWorld&, CanvasRenderingContext2D*)
{
    static NeverDestroyed<JSCanvasRenderingContext2DOwner> owner;
    return &owner.get();
}

inline void* wrapperKey(CanvasRenderingContext2D* wrappableObject)
{
    return wrappableObject;
}

JSC::JSValue toJS(JSC::ExecState*, JSDOMGlobalObject*, CanvasRenderingContext2D&);
inline JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, CanvasRenderingContext2D* impl) { return impl ? toJS(state, globalObject, *impl) : JSC::jsNull(); }
JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject*, Ref<CanvasRenderingContext2D>&&);
inline JSC::JSValue toJSNewlyCreated(JSC::ExecState* state, JSDOMGlobalObject* globalObject, RefPtr<CanvasRenderingContext2D>&& impl) { return impl ? toJSNewlyCreated(state, globalObject, impl.releaseNonNull()) : JSC::jsNull(); }

template<> struct JSDOMWrapperConverterTraits<CanvasRenderingContext2D> {
    using WrapperClass = JSCanvasRenderingContext2D;
    using ToWrappedReturnType = CanvasRenderingContext2D*;
};
template<> JSC::JSString* convertEnumerationToJS(JSC::ExecState&, CanvasRenderingContext2D::ImageSmoothingQuality);

template<> std::optional<CanvasRenderingContext2D::ImageSmoothingQuality> parseEnumeration<CanvasRenderingContext2D::ImageSmoothingQuality>(JSC::ExecState&, JSC::JSValue);
template<> CanvasRenderingContext2D::ImageSmoothingQuality convertEnumeration<CanvasRenderingContext2D::ImageSmoothingQuality>(JSC::ExecState&, JSC::JSValue);
template<> const char* expectedEnumerationValues<CanvasRenderingContext2D::ImageSmoothingQuality>();

template<> JSC::JSString* convertEnumerationToJS(JSC::ExecState&, CanvasRenderingContext2D::WindingRule);

template<> std::optional<CanvasRenderingContext2D::WindingRule> parseEnumeration<CanvasRenderingContext2D::WindingRule>(JSC::ExecState&, JSC::JSValue);
template<> CanvasRenderingContext2D::WindingRule convertEnumeration<CanvasRenderingContext2D::WindingRule>(JSC::ExecState&, JSC::JSValue);
template<> const char* expectedEnumerationValues<CanvasRenderingContext2D::WindingRule>();


} // namespace WebCore
