/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSCrypto.h"

#include "JSDOMBinding.h"
#include "JSDOMBindingCaller.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMWrapperCache.h"
#include "RuntimeEnabledFeatures.h"
#include <runtime/Error.h>
#include <runtime/FunctionPrototype.h>
#include <wtf/GetPtr.h>

#if ENABLE(SUBTLE_CRYPTO)
#include "JSDOMConvert.h"
#include "JSSubtleCrypto.h"
#include "JSWebKitSubtleCrypto.h"
#endif

using namespace JSC;

namespace WebCore {

// Functions

JSC::EncodedJSValue JSC_HOST_CALL jsCryptoPrototypeFunctionGetRandomValues(JSC::ExecState*);

// Attributes

#if ENABLE(SUBTLE_CRYPTO)
JSC::EncodedJSValue jsCryptoSubtle(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
#endif
#if ENABLE(SUBTLE_CRYPTO)
JSC::EncodedJSValue jsCryptoWebkitSubtle(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
#endif
JSC::EncodedJSValue jsCryptoConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSCryptoConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);

class JSCryptoPrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSCryptoPrototype* create(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSCryptoPrototype* ptr = new (NotNull, JSC::allocateCell<JSCryptoPrototype>(vm.heap)) JSCryptoPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSCryptoPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSCryptoConstructor = JSDOMConstructorNotConstructable<JSCrypto>;

template<> JSValue JSCryptoConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.functionPrototype();
}

template<> void JSCryptoConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSCrypto::prototype(vm, &globalObject), DontDelete | ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(&vm, String(ASCIILiteral("Crypto"))), ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), ReadOnly | DontEnum);
}

template<> const ClassInfo JSCryptoConstructor::s_info = { "Crypto", &Base::s_info, 0, CREATE_METHOD_TABLE(JSCryptoConstructor) };

/* Hash table for prototype */

static const HashTableValue JSCryptoPrototypeTableValues[] =
{
    { "constructor", DontEnum, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCryptoConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCryptoConstructor) } },
#if ENABLE(SUBTLE_CRYPTO)
    { "subtle", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCryptoSubtle), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
#else
    { 0, 0, NoIntrinsic, { 0, 0 } },
#endif
#if ENABLE(SUBTLE_CRYPTO)
    { "webkitSubtle", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCryptoWebkitSubtle), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
#else
    { 0, 0, NoIntrinsic, { 0, 0 } },
#endif
    { "getRandomValues", JSC::Function, NoIntrinsic, { (intptr_t)static_cast<NativeFunction>(jsCryptoPrototypeFunctionGetRandomValues), (intptr_t) (1) } },
};

const ClassInfo JSCryptoPrototype::s_info = { "CryptoPrototype", &Base::s_info, 0, CREATE_METHOD_TABLE(JSCryptoPrototype) };

void JSCryptoPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSCryptoPrototypeTableValues, *this);
#if ENABLE(SUBTLE_CRYPTO)
    if (!RuntimeEnabledFeatures::sharedFeatures().subtleCryptoEnabled()) {
        Identifier propertyName = Identifier::fromString(&vm, reinterpret_cast<const LChar*>("subtle"), strlen("subtle"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        JSObject::deleteProperty(this, globalObject()->globalExec(), propertyName);
    }
#endif
}

const ClassInfo JSCrypto::s_info = { "Crypto", &Base::s_info, 0, CREATE_METHOD_TABLE(JSCrypto) };

JSCrypto::JSCrypto(Structure* structure, JSDOMGlobalObject& globalObject, Ref<Crypto>&& impl)
    : JSDOMWrapper<Crypto>(structure, globalObject, WTFMove(impl))
{
}

void JSCrypto::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSCrypto::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSCryptoPrototype::create(vm, globalObject, JSCryptoPrototype::createStructure(vm, globalObject, globalObject->objectPrototype()));
}

JSObject* JSCrypto::prototype(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSCrypto>(vm, globalObject);
}

void JSCrypto::destroy(JSC::JSCell* cell)
{
    JSCrypto* thisObject = static_cast<JSCrypto*>(cell);
    thisObject->JSCrypto::~JSCrypto();
}

template<> inline JSCrypto* BindingCaller<JSCrypto>::castForAttribute(ExecState& state, EncodedJSValue thisValue)
{
    return jsDynamicDowncast<JSCrypto*>(state.vm(), JSValue::decode(thisValue));
}

template<> inline JSCrypto* BindingCaller<JSCrypto>::castForOperation(ExecState& state)
{
    return jsDynamicDowncast<JSCrypto*>(state.vm(), state.thisValue());
}

#if ENABLE(SUBTLE_CRYPTO)
static inline JSValue jsCryptoSubtleGetter(ExecState&, JSCrypto&, ThrowScope& throwScope);

EncodedJSValue jsCryptoSubtle(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSCrypto>::attribute<jsCryptoSubtleGetter>(state, thisValue, "subtle");
}

static inline JSValue jsCryptoSubtleGetter(ExecState& state, JSCrypto& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLInterface<SubtleCrypto>>(state, *thisObject.globalObject(), impl.subtle());
    return result;
}

#endif

#if ENABLE(SUBTLE_CRYPTO)
static inline JSValue jsCryptoWebkitSubtleGetter(ExecState&, JSCrypto&, ThrowScope& throwScope);

EncodedJSValue jsCryptoWebkitSubtle(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSCrypto>::attribute<jsCryptoWebkitSubtleGetter>(state, thisValue, "webkitSubtle");
}

static inline JSValue jsCryptoWebkitSubtleGetter(ExecState& state, JSCrypto& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLInterface<WebKitSubtleCrypto>>(state, *thisObject.globalObject(), throwScope, impl.webkitSubtle());
    return result;
}

#endif

EncodedJSValue jsCryptoConstructor(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    JSCryptoPrototype* domObject = jsDynamicDowncast<JSCryptoPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!domObject))
        return throwVMTypeError(state, throwScope);
    return JSValue::encode(JSCrypto::getConstructor(state->vm(), domObject->globalObject()));
}

bool setJSCryptoConstructor(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    JSValue value = JSValue::decode(encodedValue);
    JSCryptoPrototype* domObject = jsDynamicDowncast<JSCryptoPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!domObject)) {
        throwVMTypeError(state, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return domObject->putDirect(state->vm(), state->propertyNames().constructor, value);
}

JSValue JSCrypto::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSCryptoConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

static inline JSC::EncodedJSValue jsCryptoPrototypeFunctionGetRandomValuesCaller(JSC::ExecState*, JSCrypto*, JSC::ThrowScope&);

EncodedJSValue JSC_HOST_CALL jsCryptoPrototypeFunctionGetRandomValues(ExecState* state)
{
    return BindingCaller<JSCrypto>::callOperation<jsCryptoPrototypeFunctionGetRandomValuesCaller>(state, "getRandomValues");
}

static inline JSC::EncodedJSValue jsCryptoPrototypeFunctionGetRandomValuesCaller(JSC::ExecState* state, JSCrypto* castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    return JSValue::encode(castedThis->getRandomValues(*state));
}

bool JSCryptoOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    auto* jsCrypto = jsCast<JSCrypto*>(handle.slot()->asCell());
    ScriptExecutionContext* root = WTF::getPtr(jsCrypto->wrapped().scriptExecutionContext());
    if (!root)
        return false;
    return visitor.containsOpaqueRoot(root);
}

void JSCryptoOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsCrypto = static_cast<JSCrypto*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsCrypto->wrapped(), jsCrypto);
}

#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7Crypto@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore6CryptoE[]; }
#endif
#endif

JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject* globalObject, Ref<Crypto>&& impl)
{

#if ENABLE(BINDING_INTEGRITY)
    void* actualVTablePointer = *(reinterpret_cast<void**>(impl.ptr()));
#if PLATFORM(WIN)
    void* expectedVTablePointer = reinterpret_cast<void*>(__identifier("??_7Crypto@WebCore@@6B@"));
#else
    void* expectedVTablePointer = &_ZTVN7WebCore6CryptoE[2];
#if COMPILER(CLANG)
    // If this fails Crypto does not have a vtable, so you need to add the
    // ImplementationLacksVTable attribute to the interface definition
    static_assert(__is_polymorphic(Crypto), "Crypto is not polymorphic");
#endif
#endif
    // If you hit this assertion you either have a use after free bug, or
    // Crypto has subclasses. If Crypto has subclasses that get passed
    // to toJS() we currently require Crypto you to opt out of binding hardening
    // by adding the SkipVTableValidation attribute to the interface IDL definition
    RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    return createWrapper<Crypto>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, Crypto& impl)
{
    return wrap(state, globalObject, impl);
}

Crypto* JSCrypto::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicDowncast<JSCrypto*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}
