/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSDeprecatedCSSOMRect.h"

#include "JSDOMBinding.h"
#include "JSDOMBindingCaller.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMConvert.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMWrapperCache.h"
#include "JSDeprecatedCSSOMPrimitiveValue.h"
#include <runtime/FunctionPrototype.h>
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

// Attributes

JSC::EncodedJSValue jsDeprecatedCSSOMRectTop(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsDeprecatedCSSOMRectRight(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsDeprecatedCSSOMRectBottom(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsDeprecatedCSSOMRectLeft(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsDeprecatedCSSOMRectConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSDeprecatedCSSOMRectConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);

class JSDeprecatedCSSOMRectPrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSDeprecatedCSSOMRectPrototype* create(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSDeprecatedCSSOMRectPrototype* ptr = new (NotNull, JSC::allocateCell<JSDeprecatedCSSOMRectPrototype>(vm.heap)) JSDeprecatedCSSOMRectPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSDeprecatedCSSOMRectPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSDeprecatedCSSOMRectConstructor = JSDOMConstructorNotConstructable<JSDeprecatedCSSOMRect>;

template<> JSValue JSDeprecatedCSSOMRectConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.functionPrototype();
}

template<> void JSDeprecatedCSSOMRectConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSDeprecatedCSSOMRect::prototype(vm, &globalObject), DontDelete | ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(&vm, String(ASCIILiteral("Rect"))), ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), ReadOnly | DontEnum);
}

template<> const ClassInfo JSDeprecatedCSSOMRectConstructor::s_info = { "Rect", &Base::s_info, 0, CREATE_METHOD_TABLE(JSDeprecatedCSSOMRectConstructor) };

/* Hash table for prototype */

static const HashTableValue JSDeprecatedCSSOMRectPrototypeTableValues[] =
{
    { "constructor", DontEnum, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsDeprecatedCSSOMRectConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSDeprecatedCSSOMRectConstructor) } },
    { "top", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsDeprecatedCSSOMRectTop), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "right", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsDeprecatedCSSOMRectRight), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "bottom", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsDeprecatedCSSOMRectBottom), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "left", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsDeprecatedCSSOMRectLeft), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
};

const ClassInfo JSDeprecatedCSSOMRectPrototype::s_info = { "RectPrototype", &Base::s_info, 0, CREATE_METHOD_TABLE(JSDeprecatedCSSOMRectPrototype) };

void JSDeprecatedCSSOMRectPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSDeprecatedCSSOMRectPrototypeTableValues, *this);
}

const ClassInfo JSDeprecatedCSSOMRect::s_info = { "Rect", &Base::s_info, 0, CREATE_METHOD_TABLE(JSDeprecatedCSSOMRect) };

JSDeprecatedCSSOMRect::JSDeprecatedCSSOMRect(Structure* structure, JSDOMGlobalObject& globalObject, Ref<DeprecatedCSSOMRect>&& impl)
    : JSDOMWrapper<DeprecatedCSSOMRect>(structure, globalObject, WTFMove(impl))
{
}

void JSDeprecatedCSSOMRect::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSDeprecatedCSSOMRect::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSDeprecatedCSSOMRectPrototype::create(vm, globalObject, JSDeprecatedCSSOMRectPrototype::createStructure(vm, globalObject, globalObject->objectPrototype()));
}

JSObject* JSDeprecatedCSSOMRect::prototype(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSDeprecatedCSSOMRect>(vm, globalObject);
}

void JSDeprecatedCSSOMRect::destroy(JSC::JSCell* cell)
{
    JSDeprecatedCSSOMRect* thisObject = static_cast<JSDeprecatedCSSOMRect*>(cell);
    thisObject->JSDeprecatedCSSOMRect::~JSDeprecatedCSSOMRect();
}

template<> inline JSDeprecatedCSSOMRect* BindingCaller<JSDeprecatedCSSOMRect>::castForAttribute(ExecState& state, EncodedJSValue thisValue)
{
    return jsDynamicDowncast<JSDeprecatedCSSOMRect*>(state.vm(), JSValue::decode(thisValue));
}

static inline JSValue jsDeprecatedCSSOMRectTopGetter(ExecState&, JSDeprecatedCSSOMRect&, ThrowScope& throwScope);

EncodedJSValue jsDeprecatedCSSOMRectTop(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSDeprecatedCSSOMRect>::attribute<jsDeprecatedCSSOMRectTopGetter>(state, thisValue, "top");
}

static inline JSValue jsDeprecatedCSSOMRectTopGetter(ExecState& state, JSDeprecatedCSSOMRect& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLInterface<DeprecatedCSSOMPrimitiveValue>>(state, *thisObject.globalObject(), impl.top());
    return result;
}

static inline JSValue jsDeprecatedCSSOMRectRightGetter(ExecState&, JSDeprecatedCSSOMRect&, ThrowScope& throwScope);

EncodedJSValue jsDeprecatedCSSOMRectRight(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSDeprecatedCSSOMRect>::attribute<jsDeprecatedCSSOMRectRightGetter>(state, thisValue, "right");
}

static inline JSValue jsDeprecatedCSSOMRectRightGetter(ExecState& state, JSDeprecatedCSSOMRect& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLInterface<DeprecatedCSSOMPrimitiveValue>>(state, *thisObject.globalObject(), impl.right());
    return result;
}

static inline JSValue jsDeprecatedCSSOMRectBottomGetter(ExecState&, JSDeprecatedCSSOMRect&, ThrowScope& throwScope);

EncodedJSValue jsDeprecatedCSSOMRectBottom(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSDeprecatedCSSOMRect>::attribute<jsDeprecatedCSSOMRectBottomGetter>(state, thisValue, "bottom");
}

static inline JSValue jsDeprecatedCSSOMRectBottomGetter(ExecState& state, JSDeprecatedCSSOMRect& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLInterface<DeprecatedCSSOMPrimitiveValue>>(state, *thisObject.globalObject(), impl.bottom());
    return result;
}

static inline JSValue jsDeprecatedCSSOMRectLeftGetter(ExecState&, JSDeprecatedCSSOMRect&, ThrowScope& throwScope);

EncodedJSValue jsDeprecatedCSSOMRectLeft(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSDeprecatedCSSOMRect>::attribute<jsDeprecatedCSSOMRectLeftGetter>(state, thisValue, "left");
}

static inline JSValue jsDeprecatedCSSOMRectLeftGetter(ExecState& state, JSDeprecatedCSSOMRect& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLInterface<DeprecatedCSSOMPrimitiveValue>>(state, *thisObject.globalObject(), impl.left());
    return result;
}

EncodedJSValue jsDeprecatedCSSOMRectConstructor(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    JSDeprecatedCSSOMRectPrototype* domObject = jsDynamicDowncast<JSDeprecatedCSSOMRectPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!domObject))
        return throwVMTypeError(state, throwScope);
    return JSValue::encode(JSDeprecatedCSSOMRect::getConstructor(state->vm(), domObject->globalObject()));
}

bool setJSDeprecatedCSSOMRectConstructor(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    JSValue value = JSValue::decode(encodedValue);
    JSDeprecatedCSSOMRectPrototype* domObject = jsDynamicDowncast<JSDeprecatedCSSOMRectPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!domObject)) {
        throwVMTypeError(state, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return domObject->putDirect(state->vm(), state->propertyNames().constructor, value);
}

JSValue JSDeprecatedCSSOMRect::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSDeprecatedCSSOMRectConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

bool JSDeprecatedCSSOMRectOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    return false;
}

void JSDeprecatedCSSOMRectOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsDeprecatedCSSOMRect = static_cast<JSDeprecatedCSSOMRect*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsDeprecatedCSSOMRect->wrapped(), jsDeprecatedCSSOMRect);
}

JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject* globalObject, Ref<DeprecatedCSSOMRect>&& impl)
{
#if COMPILER(CLANG)
    // If you hit this failure the interface definition has the ImplementationLacksVTable
    // attribute. You should remove that attribute. If the class has subclasses
    // that may be passed through this toJS() function you should use the SkipVTableValidation
    // attribute to DeprecatedCSSOMRect.
    static_assert(!__is_polymorphic(DeprecatedCSSOMRect), "DeprecatedCSSOMRect is polymorphic but the IDL claims it is not");
#endif
    return createWrapper<DeprecatedCSSOMRect>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, DeprecatedCSSOMRect& impl)
{
    return wrap(state, globalObject, impl);
}

DeprecatedCSSOMRect* JSDeprecatedCSSOMRect::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicDowncast<JSDeprecatedCSSOMRect*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}
