/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#pragma once

#include "FontFaceSet.h"
#include "JSDOMConvert.h"
#include "JSEventTarget.h"

namespace WebCore {

class JSFontFaceSet : public JSEventTarget {
public:
    using Base = JSEventTarget;
    using DOMWrapped = FontFaceSet;
    static JSFontFaceSet* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, Ref<FontFaceSet>&& impl)
    {
        JSFontFaceSet* ptr = new (NotNull, JSC::allocateCell<JSFontFaceSet>(globalObject->vm().heap)) JSFontFaceSet(structure, *globalObject, WTFMove(impl));
        ptr->finishCreation(globalObject->vm());
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::VM&, JSC::JSGlobalObject*);
    static JSC::JSObject* prototype(JSC::VM&, JSC::JSGlobalObject*);
    static FontFaceSet* toWrapped(JSC::VM&, JSC::JSValue);

    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

    static JSC::JSValue getConstructor(JSC::VM&, const JSC::JSGlobalObject*);
    mutable JSC::WriteBarrier<JSC::Unknown> m_ready;
    static void visitChildren(JSCell*, JSC::SlotVisitor&);


    // Custom attributes
    JSC::JSValue ready(JSC::ExecState&) const;
    FontFaceSet& wrapped() const
    {
        return static_cast<FontFaceSet&>(Base::wrapped());
    }
protected:
    JSFontFaceSet(JSC::Structure*, JSDOMGlobalObject&, Ref<FontFaceSet>&&);

    void finishCreation(JSC::VM&);
};

JSC::JSValue toJS(JSC::ExecState*, JSDOMGlobalObject*, FontFaceSet&);
inline JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, FontFaceSet* impl) { return impl ? toJS(state, globalObject, *impl) : JSC::jsNull(); }
JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject*, Ref<FontFaceSet>&&);
inline JSC::JSValue toJSNewlyCreated(JSC::ExecState* state, JSDOMGlobalObject* globalObject, RefPtr<FontFaceSet>&& impl) { return impl ? toJSNewlyCreated(state, globalObject, impl.releaseNonNull()) : JSC::jsNull(); }

template<> struct JSDOMWrapperConverterTraits<FontFaceSet> {
    using WrapperClass = JSFontFaceSet;
    using ToWrappedReturnType = FontFaceSet*;
};
template<> JSC::JSString* convertEnumerationToJS(JSC::ExecState&, FontFaceSet::LoadStatus);

template<> std::optional<FontFaceSet::LoadStatus> parseEnumeration<FontFaceSet::LoadStatus>(JSC::ExecState&, JSC::JSValue);
template<> FontFaceSet::LoadStatus convertEnumeration<FontFaceSet::LoadStatus>(JSC::ExecState&, JSC::JSValue);
template<> const char* expectedEnumerationValues<FontFaceSet::LoadStatus>();


} // namespace WebCore
