/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#pragma once

#if ENABLE(INDEXED_DATABASE)

#include "IDBRequest.h"
#include "JSDOMConvert.h"
#include "JSEventTarget.h"
#include <wtf/NeverDestroyed.h>

namespace WebCore {

class JSIDBRequest : public JSEventTarget {
public:
    using Base = JSEventTarget;
    using DOMWrapped = IDBRequest;
    static JSIDBRequest* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, Ref<IDBRequest>&& impl)
    {
        JSIDBRequest* ptr = new (NotNull, JSC::allocateCell<JSIDBRequest>(globalObject->vm().heap)) JSIDBRequest(structure, *globalObject, WTFMove(impl));
        ptr->finishCreation(globalObject->vm());
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::VM&, JSC::JSGlobalObject*);
    static JSC::JSObject* prototype(JSC::VM&, JSC::JSGlobalObject*);
    static IDBRequest* toWrapped(JSC::VM&, JSC::JSValue);

    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

    static JSC::JSValue getConstructor(JSC::VM&, const JSC::JSGlobalObject*);
    static void visitChildren(JSCell*, JSC::SlotVisitor&);

    IDBRequest& wrapped() const
    {
        return static_cast<IDBRequest&>(Base::wrapped());
    }
protected:
    JSIDBRequest(JSC::Structure*, JSDOMGlobalObject&, Ref<IDBRequest>&&);

    void finishCreation(JSC::VM&);
};

class JSIDBRequestOwner : public JSC::WeakHandleOwner {
public:
    virtual bool isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown>, void* context, JSC::SlotVisitor&);
    virtual void finalize(JSC::Handle<JSC::Unknown>, void* context);
};

inline JSC::WeakHandleOwner* wrapperOwner(DOMWrapperWorld&, IDBRequest*)
{
    static NeverDestroyed<JSIDBRequestOwner> owner;
    return &owner.get();
}

inline void* wrapperKey(IDBRequest* wrappableObject)
{
    return wrappableObject;
}

JSC::JSValue toJS(JSC::ExecState*, JSDOMGlobalObject*, IDBRequest&);
inline JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, IDBRequest* impl) { return impl ? toJS(state, globalObject, *impl) : JSC::jsNull(); }
JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject*, Ref<IDBRequest>&&);
inline JSC::JSValue toJSNewlyCreated(JSC::ExecState* state, JSDOMGlobalObject* globalObject, RefPtr<IDBRequest>&& impl) { return impl ? toJSNewlyCreated(state, globalObject, impl.releaseNonNull()) : JSC::jsNull(); }

template<> struct JSDOMWrapperConverterTraits<IDBRequest> {
    using WrapperClass = JSIDBRequest;
    using ToWrappedReturnType = IDBRequest*;
};
template<> JSC::JSString* convertEnumerationToJS(JSC::ExecState&, IDBRequest::ReadyState);

template<> std::optional<IDBRequest::ReadyState> parseEnumeration<IDBRequest::ReadyState>(JSC::ExecState&, JSC::JSValue);
template<> IDBRequest::ReadyState convertEnumeration<IDBRequest::ReadyState>(JSC::ExecState&, JSC::JSValue);
template<> const char* expectedEnumerationValues<IDBRequest::ReadyState>();


} // namespace WebCore

#endif // ENABLE(INDEXED_DATABASE)
