/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#pragma once

#if ENABLE(INTERSECTION_OBSERVER)

#include "IntersectionObserverEntry.h"
#include "JSDOMConvert.h"
#include "JSDOMWrapper.h"
#include <wtf/NeverDestroyed.h>

namespace WebCore {

class JSIntersectionObserverEntry : public JSDOMWrapper<IntersectionObserverEntry> {
public:
    using Base = JSDOMWrapper<IntersectionObserverEntry>;
    static JSIntersectionObserverEntry* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, Ref<IntersectionObserverEntry>&& impl)
    {
        JSIntersectionObserverEntry* ptr = new (NotNull, JSC::allocateCell<JSIntersectionObserverEntry>(globalObject->vm().heap)) JSIntersectionObserverEntry(structure, *globalObject, WTFMove(impl));
        ptr->finishCreation(globalObject->vm());
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::VM&, JSC::JSGlobalObject*);
    static JSC::JSObject* prototype(JSC::VM&, JSC::JSGlobalObject*);
    static IntersectionObserverEntry* toWrapped(JSC::VM&, JSC::JSValue);
    static void destroy(JSC::JSCell*);

    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

    static JSC::JSValue getConstructor(JSC::VM&, const JSC::JSGlobalObject*);
protected:
    JSIntersectionObserverEntry(JSC::Structure*, JSDOMGlobalObject&, Ref<IntersectionObserverEntry>&&);

    void finishCreation(JSC::VM&);
};

class JSIntersectionObserverEntryOwner : public JSC::WeakHandleOwner {
public:
    virtual bool isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown>, void* context, JSC::SlotVisitor&);
    virtual void finalize(JSC::Handle<JSC::Unknown>, void* context);
};

inline JSC::WeakHandleOwner* wrapperOwner(DOMWrapperWorld&, IntersectionObserverEntry*)
{
    static NeverDestroyed<JSIntersectionObserverEntryOwner> owner;
    return &owner.get();
}

inline void* wrapperKey(IntersectionObserverEntry* wrappableObject)
{
    return wrappableObject;
}

JSC::JSValue toJS(JSC::ExecState*, JSDOMGlobalObject*, IntersectionObserverEntry&);
inline JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, IntersectionObserverEntry* impl) { return impl ? toJS(state, globalObject, *impl) : JSC::jsNull(); }
JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject*, Ref<IntersectionObserverEntry>&&);
inline JSC::JSValue toJSNewlyCreated(JSC::ExecState* state, JSDOMGlobalObject* globalObject, RefPtr<IntersectionObserverEntry>&& impl) { return impl ? toJSNewlyCreated(state, globalObject, impl.releaseNonNull()) : JSC::jsNull(); }

template<> struct JSDOMWrapperConverterTraits<IntersectionObserverEntry> {
    using WrapperClass = JSIntersectionObserverEntry;
    using ToWrappedReturnType = IntersectionObserverEntry*;
};
#if ENABLE(INTERSECTION_OBSERVER)

template<> IntersectionObserverEntry::Init convertDictionary<IntersectionObserverEntry::Init>(JSC::ExecState&, JSC::JSValue);

#endif


} // namespace WebCore

#endif // ENABLE(INTERSECTION_OBSERVER)
