/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSMessageEvent.h"

#include "JSDOMBinding.h"
#include "JSDOMBindingCaller.h"
#include "JSDOMConstructor.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMWindow.h"
#include "JSDOMWrapperCache.h"
#include "JSEventTarget.h"
#include "JSMessagePort.h"
#include <runtime/Error.h>
#include <runtime/JSArray.h>
#include <wtf/GetPtr.h>
#include <wtf/Variant.h>

using namespace JSC;

namespace WebCore {

template<> MessageEvent::Init convertDictionary<MessageEvent::Init>(ExecState& state, JSValue value)
{
    VM& vm = state.vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&state, throwScope);
        return { };
    }
    if (UNLIKELY(object && object->type() == RegExpObjectType)) {
        throwTypeError(&state, throwScope);
        return { };
    }
    MessageEvent::Init result;
    JSValue bubblesValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "bubbles"));
    if (!bubblesValue.isUndefined()) {
        result.bubbles = convert<IDLBoolean>(state, bubblesValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.bubbles = false;
    JSValue cancelableValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "cancelable"));
    if (!cancelableValue.isUndefined()) {
        result.cancelable = convert<IDLBoolean>(state, cancelableValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.cancelable = false;
    JSValue composedValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "composed"));
    if (!composedValue.isUndefined()) {
        result.composed = convert<IDLBoolean>(state, composedValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.composed = false;
    JSValue dataValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "data"));
    if (!dataValue.isUndefined()) {
        result.data = convert<IDLAny>(state, dataValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.data = jsNull();
    JSValue lastEventIdValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "lastEventId"));
    if (!lastEventIdValue.isUndefined()) {
        result.lastEventId = convert<IDLDOMString>(state, lastEventIdValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.lastEventId = emptyString();
    JSValue originValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "origin"));
    if (!originValue.isUndefined()) {
        result.origin = convert<IDLUSVString>(state, originValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.origin = emptyString();
    JSValue portsValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "ports"));
    if (!portsValue.isUndefined()) {
        result.ports = convert<IDLSequence<IDLInterface<MessagePort>>>(state, portsValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.ports = Converter<IDLSequence<IDLInterface<MessagePort>>>::ReturnType{ };
    JSValue sourceValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "source"));
    if (!sourceValue.isUndefined()) {
        result.source = convert<IDLNullable<IDLUnion<IDLInterface<DOMWindow>, IDLInterface<MessagePort>>>>(state, sourceValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.source = std::nullopt;
    return result;
}

// Functions

JSC::EncodedJSValue JSC_HOST_CALL jsMessageEventPrototypeFunctionInitMessageEvent(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsMessageEventPrototypeFunctionWebkitInitMessageEvent(JSC::ExecState*);

// Attributes

JSC::EncodedJSValue jsMessageEventOrigin(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsMessageEventLastEventId(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsMessageEventSource(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsMessageEventData(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsMessageEventPorts(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsMessageEventConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSMessageEventConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);

class JSMessageEventPrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSMessageEventPrototype* create(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSMessageEventPrototype* ptr = new (NotNull, JSC::allocateCell<JSMessageEventPrototype>(vm.heap)) JSMessageEventPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSMessageEventPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSMessageEventConstructor = JSDOMConstructor<JSMessageEvent>;

template<> EncodedJSValue JSC_HOST_CALL JSMessageEventConstructor::construct(ExecState* state)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    auto* castedThis = jsCast<JSMessageEventConstructor*>(state->jsCallee());
    ASSERT(castedThis);
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto type = convert<IDLDOMString>(*state, state->uncheckedArgument(0), StringConversionConfiguration::Normal);
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto eventInitDict = convert<IDLDictionary<MessageEvent::Init>>(*state, state->argument(1));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto object = MessageEvent::create(*state, WTFMove(type), WTFMove(eventInitDict));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    return JSValue::encode(toJSNewlyCreated<IDLInterface<MessageEvent>>(*state, *castedThis->globalObject(), WTFMove(object)));
}

template<> JSValue JSMessageEventConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    return JSEvent::getConstructor(vm, &globalObject);
}

template<> void JSMessageEventConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSMessageEvent::prototype(vm, &globalObject), DontDelete | ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(&vm, String(ASCIILiteral("MessageEvent"))), ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(1), ReadOnly | DontEnum);
}

template<> const ClassInfo JSMessageEventConstructor::s_info = { "MessageEvent", &Base::s_info, 0, CREATE_METHOD_TABLE(JSMessageEventConstructor) };

/* Hash table for prototype */

static const HashTableValue JSMessageEventPrototypeTableValues[] =
{
    { "constructor", DontEnum, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMessageEventConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMessageEventConstructor) } },
    { "origin", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMessageEventOrigin), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "lastEventId", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMessageEventLastEventId), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "source", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMessageEventSource), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "data", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMessageEventData), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "ports", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMessageEventPorts), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "initMessageEvent", JSC::Function, NoIntrinsic, { (intptr_t)static_cast<NativeFunction>(jsMessageEventPrototypeFunctionInitMessageEvent), (intptr_t) (1) } },
    { "webkitInitMessageEvent", JSC::Function, NoIntrinsic, { (intptr_t)static_cast<NativeFunction>(jsMessageEventPrototypeFunctionWebkitInitMessageEvent), (intptr_t) (0) } },
};

const ClassInfo JSMessageEventPrototype::s_info = { "MessageEventPrototype", &Base::s_info, 0, CREATE_METHOD_TABLE(JSMessageEventPrototype) };

void JSMessageEventPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSMessageEventPrototypeTableValues, *this);
}

const ClassInfo JSMessageEvent::s_info = { "MessageEvent", &Base::s_info, 0, CREATE_METHOD_TABLE(JSMessageEvent) };

JSMessageEvent::JSMessageEvent(Structure* structure, JSDOMGlobalObject& globalObject, Ref<MessageEvent>&& impl)
    : JSEvent(structure, globalObject, WTFMove(impl))
{
}

void JSMessageEvent::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSMessageEvent::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSMessageEventPrototype::create(vm, globalObject, JSMessageEventPrototype::createStructure(vm, globalObject, JSEvent::prototype(vm, globalObject)));
}

JSObject* JSMessageEvent::prototype(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSMessageEvent>(vm, globalObject);
}

template<> inline JSMessageEvent* BindingCaller<JSMessageEvent>::castForAttribute(ExecState& state, EncodedJSValue thisValue)
{
    return jsDynamicDowncast<JSMessageEvent*>(state.vm(), JSValue::decode(thisValue));
}

template<> inline JSMessageEvent* BindingCaller<JSMessageEvent>::castForOperation(ExecState& state)
{
    return jsDynamicDowncast<JSMessageEvent*>(state.vm(), state.thisValue());
}

static inline JSValue jsMessageEventOriginGetter(ExecState&, JSMessageEvent&, ThrowScope& throwScope);

EncodedJSValue jsMessageEventOrigin(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSMessageEvent>::attribute<jsMessageEventOriginGetter>(state, thisValue, "origin");
}

static inline JSValue jsMessageEventOriginGetter(ExecState& state, JSMessageEvent& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUSVString>(state, impl.origin());
    return result;
}

static inline JSValue jsMessageEventLastEventIdGetter(ExecState&, JSMessageEvent&, ThrowScope& throwScope);

EncodedJSValue jsMessageEventLastEventId(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSMessageEvent>::attribute<jsMessageEventLastEventIdGetter>(state, thisValue, "lastEventId");
}

static inline JSValue jsMessageEventLastEventIdGetter(ExecState& state, JSMessageEvent& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLDOMString>(state, impl.lastEventId());
    return result;
}

static inline JSValue jsMessageEventSourceGetter(ExecState&, JSMessageEvent&, ThrowScope& throwScope);

EncodedJSValue jsMessageEventSource(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSMessageEvent>::attribute<jsMessageEventSourceGetter>(state, thisValue, "source");
}

static inline JSValue jsMessageEventSourceGetter(ExecState& state, JSMessageEvent& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLNullable<IDLInterface<EventTarget>>>(state, *thisObject.globalObject(), impl.source());
    return result;
}

static inline JSValue jsMessageEventDataGetter(ExecState&, JSMessageEvent&, ThrowScope& throwScope);

EncodedJSValue jsMessageEventData(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSMessageEvent>::attribute<jsMessageEventDataGetter>(state, thisValue, "data");
}

static inline JSValue jsMessageEventDataGetter(ExecState& state, JSMessageEvent& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    return thisObject.data(state);
}

static inline JSValue jsMessageEventPortsGetter(ExecState&, JSMessageEvent&, ThrowScope& throwScope);

EncodedJSValue jsMessageEventPorts(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSMessageEvent>::attribute<jsMessageEventPortsGetter>(state, thisValue, "ports");
}

static inline JSValue jsMessageEventPortsGetter(ExecState& state, JSMessageEvent& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLFrozenArray<IDLInterface<MessagePort>>>(state, *thisObject.globalObject(), impl.ports());
    return result;
}

EncodedJSValue jsMessageEventConstructor(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    JSMessageEventPrototype* domObject = jsDynamicDowncast<JSMessageEventPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!domObject))
        return throwVMTypeError(state, throwScope);
    return JSValue::encode(JSMessageEvent::getConstructor(state->vm(), domObject->globalObject()));
}

bool setJSMessageEventConstructor(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    JSValue value = JSValue::decode(encodedValue);
    JSMessageEventPrototype* domObject = jsDynamicDowncast<JSMessageEventPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!domObject)) {
        throwVMTypeError(state, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return domObject->putDirect(state->vm(), state->propertyNames().constructor, value);
}

JSValue JSMessageEvent::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSMessageEventConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

static inline JSC::EncodedJSValue jsMessageEventPrototypeFunctionInitMessageEventCaller(JSC::ExecState*, JSMessageEvent*, JSC::ThrowScope&);

EncodedJSValue JSC_HOST_CALL jsMessageEventPrototypeFunctionInitMessageEvent(ExecState* state)
{
    return BindingCaller<JSMessageEvent>::callOperation<jsMessageEventPrototypeFunctionInitMessageEventCaller>(state, "initMessageEvent");
}

static inline JSC::EncodedJSValue jsMessageEventPrototypeFunctionInitMessageEventCaller(JSC::ExecState* state, JSMessageEvent* castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto type = convert<IDLDOMString>(*state, state->uncheckedArgument(0), StringConversionConfiguration::Normal);
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto bubbles = convert<IDLBoolean>(*state, state->argument(1));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto cancelable = convert<IDLBoolean>(*state, state->argument(2));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto data = state->argument(3).isUndefined() ? jsNull() : convert<IDLAny>(*state, state->uncheckedArgument(3));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto originArg = state->argument(4).isUndefined() ? emptyString() : convert<IDLUSVString>(*state, state->uncheckedArgument(4), StringConversionConfiguration::Normal);
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto lastEventId = state->argument(5).isUndefined() ? emptyString() : convert<IDLDOMString>(*state, state->uncheckedArgument(5), StringConversionConfiguration::Normal);
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto source = state->argument(6).isUndefined() ? std::nullopt : convert<IDLNullable<IDLUnion<IDLInterface<DOMWindow>, IDLInterface<MessagePort>>>>(*state, state->uncheckedArgument(6));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto messagePorts = state->argument(7).isUndefined() ? Converter<IDLSequence<IDLInterface<MessagePort>>>::ReturnType{ } : convert<IDLSequence<IDLInterface<MessagePort>>>(*state, state->uncheckedArgument(7));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    impl.initMessageEvent(*state, WTFMove(type), WTFMove(bubbles), WTFMove(cancelable), WTFMove(data), WTFMove(originArg), WTFMove(lastEventId), WTFMove(source), WTFMove(messagePorts));
    return JSValue::encode(jsUndefined());
}

static inline JSC::EncodedJSValue jsMessageEventPrototypeFunctionWebkitInitMessageEventCaller(JSC::ExecState*, JSMessageEvent*, JSC::ThrowScope&);

EncodedJSValue JSC_HOST_CALL jsMessageEventPrototypeFunctionWebkitInitMessageEvent(ExecState* state)
{
    return BindingCaller<JSMessageEvent>::callOperation<jsMessageEventPrototypeFunctionWebkitInitMessageEventCaller>(state, "webkitInitMessageEvent");
}

static inline JSC::EncodedJSValue jsMessageEventPrototypeFunctionWebkitInitMessageEventCaller(JSC::ExecState* state, JSMessageEvent* castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    return JSValue::encode(castedThis->webkitInitMessageEvent(*state));
}

void JSMessageEvent::visitChildren(JSCell* cell, SlotVisitor& visitor)
{
    auto* thisObject = jsCast<JSMessageEvent*>(cell);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    Base::visitChildren(thisObject, visitor);
    visitor.append(thisObject->m_data);
}

#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7MessageEvent@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore12MessageEventE[]; }
#endif
#endif

JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject* globalObject, Ref<MessageEvent>&& impl)
{

#if ENABLE(BINDING_INTEGRITY)
    void* actualVTablePointer = *(reinterpret_cast<void**>(impl.ptr()));
#if PLATFORM(WIN)
    void* expectedVTablePointer = reinterpret_cast<void*>(__identifier("??_7MessageEvent@WebCore@@6B@"));
#else
    void* expectedVTablePointer = &_ZTVN7WebCore12MessageEventE[2];
#if COMPILER(CLANG)
    // If this fails MessageEvent does not have a vtable, so you need to add the
    // ImplementationLacksVTable attribute to the interface definition
    static_assert(__is_polymorphic(MessageEvent), "MessageEvent is not polymorphic");
#endif
#endif
    // If you hit this assertion you either have a use after free bug, or
    // MessageEvent has subclasses. If MessageEvent has subclasses that get passed
    // to toJS() we currently require MessageEvent you to opt out of binding hardening
    // by adding the SkipVTableValidation attribute to the interface IDL definition
    RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    return createWrapper<MessageEvent>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, MessageEvent& impl)
{
    return wrap(state, globalObject, impl);
}


}
