/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSNavigator.h"

#include "JSDOMBinding.h"
#include "JSDOMBindingCaller.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMConvert.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMMimeTypeArray.h"
#include "JSDOMPluginArray.h"
#include "JSDOMWrapperCache.h"
#include "NavigatorGeolocation.h"
#include "NavigatorMediaDevices.h"
#include "RuntimeEnabledFeatures.h"
#include <runtime/Error.h>
#include <runtime/FunctionPrototype.h>
#include <runtime/JSArray.h>
#include <wtf/GetPtr.h>

#if (ENABLE(CUSTOM_SCHEME_HANDLER) && ENABLE(NAVIGATOR_CONTENT_UTILS)) || ENABLE(NAVIGATOR_CONTENT_UTILS)
#include "NavigatorContentUtils.h"
#endif

#if ENABLE(GEOLOCATION)
#include "JSGeolocation.h"
#endif

#if ENABLE(MEDIA_STREAM)
#include "JSMediaDevices.h"
#include "NavigatorUserMediaBuiltins.h"
#endif

#if ENABLE(VIBRATION)
#include "NavigatorVibration.h"
#include <runtime/IteratorOperations.h>
#endif

using namespace JSC;

namespace WebCore {

// Functions

JSC::EncodedJSValue JSC_HOST_CALL jsNavigatorPrototypeFunctionJavaEnabled(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsNavigatorPrototypeFunctionGetStorageUpdates(JSC::ExecState*);
#if ENABLE(NAVIGATOR_CONTENT_UTILS)
JSC::EncodedJSValue JSC_HOST_CALL jsNavigatorPrototypeFunctionRegisterProtocolHandler(JSC::ExecState*);
#endif
#if ENABLE(CUSTOM_SCHEME_HANDLER) && ENABLE(NAVIGATOR_CONTENT_UTILS)
JSC::EncodedJSValue JSC_HOST_CALL jsNavigatorPrototypeFunctionIsProtocolHandlerRegistered(JSC::ExecState*);
#endif
#if ENABLE(CUSTOM_SCHEME_HANDLER) && ENABLE(NAVIGATOR_CONTENT_UTILS)
JSC::EncodedJSValue JSC_HOST_CALL jsNavigatorPrototypeFunctionUnregisterProtocolHandler(JSC::ExecState*);
#endif
#if ENABLE(VIBRATION)
JSC::EncodedJSValue JSC_HOST_CALL jsNavigatorPrototypeFunctionVibrate(JSC::ExecState*);
#endif

// Attributes

JSC::EncodedJSValue jsNavigatorPlugins(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsNavigatorMimeTypes(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsNavigatorCookieEnabled(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
#if ENABLE(GEOLOCATION)
JSC::EncodedJSValue jsNavigatorGeolocation(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
#endif
#if ENABLE(MEDIA_STREAM)
JSC::EncodedJSValue jsNavigatorMediaDevices(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
#endif
JSC::EncodedJSValue jsNavigatorWebdriver(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
#if ENABLE(NAVIGATOR_HWCONCURRENCY)
JSC::EncodedJSValue jsNavigatorHardwareConcurrency(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
#endif
JSC::EncodedJSValue jsNavigatorAppCodeName(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsNavigatorAppName(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsNavigatorAppVersion(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsNavigatorPlatform(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsNavigatorProduct(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsNavigatorProductSub(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsNavigatorUserAgent(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsNavigatorVendor(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsNavigatorVendorSub(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsNavigatorLanguage(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsNavigatorLanguages(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsNavigatorOnLine(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsNavigatorConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSNavigatorConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);

class JSNavigatorPrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSNavigatorPrototype* create(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSNavigatorPrototype* ptr = new (NotNull, JSC::allocateCell<JSNavigatorPrototype>(vm.heap)) JSNavigatorPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSNavigatorPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSNavigatorConstructor = JSDOMConstructorNotConstructable<JSNavigator>;

template<> JSValue JSNavigatorConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.functionPrototype();
}

template<> void JSNavigatorConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSNavigator::prototype(vm, &globalObject), DontDelete | ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(&vm, String(ASCIILiteral("Navigator"))), ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), ReadOnly | DontEnum);
}

template<> const ClassInfo JSNavigatorConstructor::s_info = { "Navigator", &Base::s_info, 0, CREATE_METHOD_TABLE(JSNavigatorConstructor) };

/* Hash table for prototype */

static const HashTableValue JSNavigatorPrototypeTableValues[] =
{
    { "constructor", DontEnum, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsNavigatorConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSNavigatorConstructor) } },
    { "plugins", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsNavigatorPlugins), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "mimeTypes", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsNavigatorMimeTypes), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "cookieEnabled", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsNavigatorCookieEnabled), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
#if ENABLE(GEOLOCATION)
    { "geolocation", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsNavigatorGeolocation), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
#else
    { 0, 0, NoIntrinsic, { 0, 0 } },
#endif
#if ENABLE(MEDIA_STREAM)
    { "mediaDevices", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsNavigatorMediaDevices), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
#else
    { 0, 0, NoIntrinsic, { 0, 0 } },
#endif
    { "webdriver", DontEnum | ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsNavigatorWebdriver), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
#if ENABLE(NAVIGATOR_HWCONCURRENCY)
    { "hardwareConcurrency", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsNavigatorHardwareConcurrency), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
#else
    { 0, 0, NoIntrinsic, { 0, 0 } },
#endif
    { "appCodeName", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsNavigatorAppCodeName), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "appName", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsNavigatorAppName), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "appVersion", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsNavigatorAppVersion), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "platform", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsNavigatorPlatform), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "product", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsNavigatorProduct), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "productSub", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsNavigatorProductSub), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "userAgent", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsNavigatorUserAgent), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "vendor", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsNavigatorVendor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "vendorSub", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsNavigatorVendorSub), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "language", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsNavigatorLanguage), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "languages", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsNavigatorLanguages), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "onLine", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsNavigatorOnLine), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "javaEnabled", JSC::Function, NoIntrinsic, { (intptr_t)static_cast<NativeFunction>(jsNavigatorPrototypeFunctionJavaEnabled), (intptr_t) (0) } },
    { "getStorageUpdates", JSC::Function, NoIntrinsic, { (intptr_t)static_cast<NativeFunction>(jsNavigatorPrototypeFunctionGetStorageUpdates), (intptr_t) (0) } },
#if ENABLE(MEDIA_STREAM)
    { "getUserMedia", JSC::Builtin, NoIntrinsic, { (intptr_t)static_cast<BuiltinGenerator>(navigatorUserMediaGetUserMediaCodeGenerator), (intptr_t) (3) } },
#else
    { 0, 0, NoIntrinsic, { 0, 0 } },
#endif
#if ENABLE(NAVIGATOR_CONTENT_UTILS)
    { "registerProtocolHandler", JSC::Function, NoIntrinsic, { (intptr_t)static_cast<NativeFunction>(jsNavigatorPrototypeFunctionRegisterProtocolHandler), (intptr_t) (3) } },
#else
    { 0, 0, NoIntrinsic, { 0, 0 } },
#endif
#if ENABLE(CUSTOM_SCHEME_HANDLER) && ENABLE(NAVIGATOR_CONTENT_UTILS)
    { "isProtocolHandlerRegistered", JSC::Function, NoIntrinsic, { (intptr_t)static_cast<NativeFunction>(jsNavigatorPrototypeFunctionIsProtocolHandlerRegistered), (intptr_t) (2) } },
#else
    { 0, 0, NoIntrinsic, { 0, 0 } },
#endif
#if ENABLE(CUSTOM_SCHEME_HANDLER) && ENABLE(NAVIGATOR_CONTENT_UTILS)
    { "unregisterProtocolHandler", JSC::Function, NoIntrinsic, { (intptr_t)static_cast<NativeFunction>(jsNavigatorPrototypeFunctionUnregisterProtocolHandler), (intptr_t) (2) } },
#else
    { 0, 0, NoIntrinsic, { 0, 0 } },
#endif
#if ENABLE(VIBRATION)
    { "vibrate", JSC::Function, NoIntrinsic, { (intptr_t)static_cast<NativeFunction>(jsNavigatorPrototypeFunctionVibrate), (intptr_t) (1) } },
#else
    { 0, 0, NoIntrinsic, { 0, 0 } },
#endif
};

const ClassInfo JSNavigatorPrototype::s_info = { "NavigatorPrototype", &Base::s_info, 0, CREATE_METHOD_TABLE(JSNavigatorPrototype) };

void JSNavigatorPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSNavigatorPrototypeTableValues, *this);
#if ENABLE(MEDIA_STREAM)
    if (!RuntimeEnabledFeatures::sharedFeatures().mediaStreamEnabled()) {
        Identifier propertyName = Identifier::fromString(&vm, reinterpret_cast<const LChar*>("getUserMedia"), strlen("getUserMedia"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        JSObject::deleteProperty(this, globalObject()->globalExec(), propertyName);
    }
#endif
#if ENABLE(MEDIA_STREAM)
    if (!RuntimeEnabledFeatures::sharedFeatures().mediaStreamEnabled()) {
        Identifier propertyName = Identifier::fromString(&vm, reinterpret_cast<const LChar*>("mediaDevices"), strlen("mediaDevices"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        JSObject::deleteProperty(this, globalObject()->globalExec(), propertyName);
    }
#endif
}

const ClassInfo JSNavigator::s_info = { "Navigator", &Base::s_info, 0, CREATE_METHOD_TABLE(JSNavigator) };

JSNavigator::JSNavigator(Structure* structure, JSDOMGlobalObject& globalObject, Ref<Navigator>&& impl)
    : JSDOMWrapper<Navigator>(structure, globalObject, WTFMove(impl))
{
}

void JSNavigator::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSNavigator::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSNavigatorPrototype::create(vm, globalObject, JSNavigatorPrototype::createStructure(vm, globalObject, globalObject->objectPrototype()));
}

JSObject* JSNavigator::prototype(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSNavigator>(vm, globalObject);
}

void JSNavigator::destroy(JSC::JSCell* cell)
{
    JSNavigator* thisObject = static_cast<JSNavigator*>(cell);
    thisObject->JSNavigator::~JSNavigator();
}

template<> inline JSNavigator* BindingCaller<JSNavigator>::castForAttribute(ExecState& state, EncodedJSValue thisValue)
{
    return jsDynamicDowncast<JSNavigator*>(state.vm(), JSValue::decode(thisValue));
}

template<> inline JSNavigator* BindingCaller<JSNavigator>::castForOperation(ExecState& state)
{
    return jsDynamicDowncast<JSNavigator*>(state.vm(), state.thisValue());
}

static inline JSValue jsNavigatorPluginsGetter(ExecState&, JSNavigator&, ThrowScope& throwScope);

EncodedJSValue jsNavigatorPlugins(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSNavigator>::attribute<jsNavigatorPluginsGetter>(state, thisValue, "plugins");
}

static inline JSValue jsNavigatorPluginsGetter(ExecState& state, JSNavigator& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLInterface<DOMPluginArray>>(state, *thisObject.globalObject(), impl.plugins());
    return result;
}

static inline JSValue jsNavigatorMimeTypesGetter(ExecState&, JSNavigator&, ThrowScope& throwScope);

EncodedJSValue jsNavigatorMimeTypes(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSNavigator>::attribute<jsNavigatorMimeTypesGetter>(state, thisValue, "mimeTypes");
}

static inline JSValue jsNavigatorMimeTypesGetter(ExecState& state, JSNavigator& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLInterface<DOMMimeTypeArray>>(state, *thisObject.globalObject(), impl.mimeTypes());
    return result;
}

static inline JSValue jsNavigatorCookieEnabledGetter(ExecState&, JSNavigator&, ThrowScope& throwScope);

EncodedJSValue jsNavigatorCookieEnabled(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSNavigator>::attribute<jsNavigatorCookieEnabledGetter>(state, thisValue, "cookieEnabled");
}

static inline JSValue jsNavigatorCookieEnabledGetter(ExecState& state, JSNavigator& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLBoolean>(impl.cookieEnabled());
    return result;
}

#if ENABLE(GEOLOCATION)
static inline JSValue jsNavigatorGeolocationGetter(ExecState&, JSNavigator&, ThrowScope& throwScope);

EncodedJSValue jsNavigatorGeolocation(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSNavigator>::attribute<jsNavigatorGeolocationGetter>(state, thisValue, "geolocation");
}

static inline JSValue jsNavigatorGeolocationGetter(ExecState& state, JSNavigator& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLInterface<Geolocation>>(state, *thisObject.globalObject(), WebCore::NavigatorGeolocation::geolocation(impl));
    return result;
}

#endif

#if ENABLE(MEDIA_STREAM)
static inline JSValue jsNavigatorMediaDevicesGetter(ExecState&, JSNavigator&, ThrowScope& throwScope);

EncodedJSValue jsNavigatorMediaDevices(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSNavigator>::attribute<jsNavigatorMediaDevicesGetter>(state, thisValue, "mediaDevices");
}

static inline JSValue jsNavigatorMediaDevicesGetter(ExecState& state, JSNavigator& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLInterface<MediaDevices>>(state, *thisObject.globalObject(), WebCore::NavigatorMediaDevices::mediaDevices(impl));
    return result;
}

#endif

static inline JSValue jsNavigatorWebdriverGetter(ExecState&, JSNavigator&, ThrowScope& throwScope);

EncodedJSValue jsNavigatorWebdriver(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSNavigator>::attribute<jsNavigatorWebdriverGetter>(state, thisValue, "webdriver");
}

static inline JSValue jsNavigatorWebdriverGetter(ExecState& state, JSNavigator& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    return thisObject.webdriver(state);
}

#if ENABLE(NAVIGATOR_HWCONCURRENCY)
static inline JSValue jsNavigatorHardwareConcurrencyGetter(ExecState&, JSNavigator&, ThrowScope& throwScope);

EncodedJSValue jsNavigatorHardwareConcurrency(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSNavigator>::attribute<jsNavigatorHardwareConcurrencyGetter>(state, thisValue, "hardwareConcurrency");
}

static inline JSValue jsNavigatorHardwareConcurrencyGetter(ExecState& state, JSNavigator& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnsignedLongLong>(impl.hardwareConcurrency());
    return result;
}

#endif

static inline JSValue jsNavigatorAppCodeNameGetter(ExecState&, JSNavigator&, ThrowScope& throwScope);

EncodedJSValue jsNavigatorAppCodeName(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSNavigator>::attribute<jsNavigatorAppCodeNameGetter>(state, thisValue, "appCodeName");
}

static inline JSValue jsNavigatorAppCodeNameGetter(ExecState& state, JSNavigator& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLDOMString>(state, impl.appCodeName());
    return result;
}

static inline JSValue jsNavigatorAppNameGetter(ExecState&, JSNavigator&, ThrowScope& throwScope);

EncodedJSValue jsNavigatorAppName(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSNavigator>::attribute<jsNavigatorAppNameGetter>(state, thisValue, "appName");
}

static inline JSValue jsNavigatorAppNameGetter(ExecState& state, JSNavigator& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLDOMString>(state, impl.appName());
    return result;
}

static inline JSValue jsNavigatorAppVersionGetter(ExecState&, JSNavigator&, ThrowScope& throwScope);

EncodedJSValue jsNavigatorAppVersion(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSNavigator>::attribute<jsNavigatorAppVersionGetter>(state, thisValue, "appVersion");
}

static inline JSValue jsNavigatorAppVersionGetter(ExecState& state, JSNavigator& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLDOMString>(state, impl.appVersion());
    return result;
}

static inline JSValue jsNavigatorPlatformGetter(ExecState&, JSNavigator&, ThrowScope& throwScope);

EncodedJSValue jsNavigatorPlatform(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSNavigator>::attribute<jsNavigatorPlatformGetter>(state, thisValue, "platform");
}

static inline JSValue jsNavigatorPlatformGetter(ExecState& state, JSNavigator& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLDOMString>(state, impl.platform());
    return result;
}

static inline JSValue jsNavigatorProductGetter(ExecState&, JSNavigator&, ThrowScope& throwScope);

EncodedJSValue jsNavigatorProduct(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSNavigator>::attribute<jsNavigatorProductGetter>(state, thisValue, "product");
}

static inline JSValue jsNavigatorProductGetter(ExecState& state, JSNavigator& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLDOMString>(state, impl.product());
    return result;
}

static inline JSValue jsNavigatorProductSubGetter(ExecState&, JSNavigator&, ThrowScope& throwScope);

EncodedJSValue jsNavigatorProductSub(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSNavigator>::attribute<jsNavigatorProductSubGetter>(state, thisValue, "productSub");
}

static inline JSValue jsNavigatorProductSubGetter(ExecState& state, JSNavigator& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLDOMString>(state, impl.productSub());
    return result;
}

static inline JSValue jsNavigatorUserAgentGetter(ExecState&, JSNavigator&, ThrowScope& throwScope);

EncodedJSValue jsNavigatorUserAgent(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSNavigator>::attribute<jsNavigatorUserAgentGetter>(state, thisValue, "userAgent");
}

static inline JSValue jsNavigatorUserAgentGetter(ExecState& state, JSNavigator& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLDOMString>(state, impl.userAgent());
    return result;
}

static inline JSValue jsNavigatorVendorGetter(ExecState&, JSNavigator&, ThrowScope& throwScope);

EncodedJSValue jsNavigatorVendor(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSNavigator>::attribute<jsNavigatorVendorGetter>(state, thisValue, "vendor");
}

static inline JSValue jsNavigatorVendorGetter(ExecState& state, JSNavigator& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLDOMString>(state, impl.vendor());
    return result;
}

static inline JSValue jsNavigatorVendorSubGetter(ExecState&, JSNavigator&, ThrowScope& throwScope);

EncodedJSValue jsNavigatorVendorSub(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSNavigator>::attribute<jsNavigatorVendorSubGetter>(state, thisValue, "vendorSub");
}

static inline JSValue jsNavigatorVendorSubGetter(ExecState& state, JSNavigator& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLDOMString>(state, impl.vendorSub());
    return result;
}

static inline JSValue jsNavigatorLanguageGetter(ExecState&, JSNavigator&, ThrowScope& throwScope);

EncodedJSValue jsNavigatorLanguage(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSNavigator>::attribute<jsNavigatorLanguageGetter>(state, thisValue, "language");
}

static inline JSValue jsNavigatorLanguageGetter(ExecState& state, JSNavigator& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLDOMString>(state, impl.language());
    return result;
}

static inline JSValue jsNavigatorLanguagesGetter(ExecState&, JSNavigator&, ThrowScope& throwScope);

EncodedJSValue jsNavigatorLanguages(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSNavigator>::attribute<jsNavigatorLanguagesGetter>(state, thisValue, "languages");
}

static inline JSValue jsNavigatorLanguagesGetter(ExecState& state, JSNavigator& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLFrozenArray<IDLDOMString>>(state, *thisObject.globalObject(), impl.languages());
    return result;
}

static inline JSValue jsNavigatorOnLineGetter(ExecState&, JSNavigator&, ThrowScope& throwScope);

EncodedJSValue jsNavigatorOnLine(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSNavigator>::attribute<jsNavigatorOnLineGetter>(state, thisValue, "onLine");
}

static inline JSValue jsNavigatorOnLineGetter(ExecState& state, JSNavigator& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLBoolean>(impl.onLine());
    return result;
}

EncodedJSValue jsNavigatorConstructor(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    JSNavigatorPrototype* domObject = jsDynamicDowncast<JSNavigatorPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!domObject))
        return throwVMTypeError(state, throwScope);
    return JSValue::encode(JSNavigator::getConstructor(state->vm(), domObject->globalObject()));
}

bool setJSNavigatorConstructor(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    JSValue value = JSValue::decode(encodedValue);
    JSNavigatorPrototype* domObject = jsDynamicDowncast<JSNavigatorPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!domObject)) {
        throwVMTypeError(state, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return domObject->putDirect(state->vm(), state->propertyNames().constructor, value);
}

JSValue JSNavigator::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSNavigatorConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

static inline JSC::EncodedJSValue jsNavigatorPrototypeFunctionJavaEnabledCaller(JSC::ExecState*, JSNavigator*, JSC::ThrowScope&);

EncodedJSValue JSC_HOST_CALL jsNavigatorPrototypeFunctionJavaEnabled(ExecState* state)
{
    return BindingCaller<JSNavigator>::callOperation<jsNavigatorPrototypeFunctionJavaEnabledCaller>(state, "javaEnabled");
}

static inline JSC::EncodedJSValue jsNavigatorPrototypeFunctionJavaEnabledCaller(JSC::ExecState* state, JSNavigator* castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    return JSValue::encode(toJS<IDLBoolean>(impl.javaEnabled()));
}

static inline JSC::EncodedJSValue jsNavigatorPrototypeFunctionGetStorageUpdatesCaller(JSC::ExecState*, JSNavigator*, JSC::ThrowScope&);

EncodedJSValue JSC_HOST_CALL jsNavigatorPrototypeFunctionGetStorageUpdates(ExecState* state)
{
    return BindingCaller<JSNavigator>::callOperation<jsNavigatorPrototypeFunctionGetStorageUpdatesCaller>(state, "getStorageUpdates");
}

static inline JSC::EncodedJSValue jsNavigatorPrototypeFunctionGetStorageUpdatesCaller(JSC::ExecState* state, JSNavigator* castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    impl.getStorageUpdates();
    return JSValue::encode(jsUndefined());
}

#if ENABLE(NAVIGATOR_CONTENT_UTILS)
static inline JSC::EncodedJSValue jsNavigatorPrototypeFunctionRegisterProtocolHandlerCaller(JSC::ExecState*, JSNavigator*, JSC::ThrowScope&);

EncodedJSValue JSC_HOST_CALL jsNavigatorPrototypeFunctionRegisterProtocolHandler(ExecState* state)
{
    return BindingCaller<JSNavigator>::callOperation<jsNavigatorPrototypeFunctionRegisterProtocolHandlerCaller>(state, "registerProtocolHandler");
}

static inline JSC::EncodedJSValue jsNavigatorPrototypeFunctionRegisterProtocolHandlerCaller(JSC::ExecState* state, JSNavigator* castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 3))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto scheme = convert<IDLDOMString>(*state, state->uncheckedArgument(0), StringConversionConfiguration::Normal);
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto url = convert<IDLDOMString>(*state, state->uncheckedArgument(1), StringConversionConfiguration::Normal);
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto title = convert<IDLDOMString>(*state, state->uncheckedArgument(2), StringConversionConfiguration::Normal);
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    propagateException(*state, throwScope, WebCore::NavigatorContentUtils::registerProtocolHandler(impl, WTFMove(scheme), WTFMove(url), WTFMove(title)));
    return JSValue::encode(jsUndefined());
}

#endif

#if ENABLE(CUSTOM_SCHEME_HANDLER) && ENABLE(NAVIGATOR_CONTENT_UTILS)
static inline JSC::EncodedJSValue jsNavigatorPrototypeFunctionIsProtocolHandlerRegisteredCaller(JSC::ExecState*, JSNavigator*, JSC::ThrowScope&);

EncodedJSValue JSC_HOST_CALL jsNavigatorPrototypeFunctionIsProtocolHandlerRegistered(ExecState* state)
{
    return BindingCaller<JSNavigator>::callOperation<jsNavigatorPrototypeFunctionIsProtocolHandlerRegisteredCaller>(state, "isProtocolHandlerRegistered");
}

static inline JSC::EncodedJSValue jsNavigatorPrototypeFunctionIsProtocolHandlerRegisteredCaller(JSC::ExecState* state, JSNavigator* castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 2))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto scheme = convert<IDLDOMString>(*state, state->uncheckedArgument(0), StringConversionConfiguration::Normal);
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto url = convert<IDLDOMString>(*state, state->uncheckedArgument(1), StringConversionConfiguration::Normal);
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    return JSValue::encode(toJS<IDLDOMString>(*state, throwScope, WebCore::NavigatorContentUtils::isProtocolHandlerRegistered(impl, WTFMove(scheme), WTFMove(url))));
}

#endif

#if ENABLE(CUSTOM_SCHEME_HANDLER) && ENABLE(NAVIGATOR_CONTENT_UTILS)
static inline JSC::EncodedJSValue jsNavigatorPrototypeFunctionUnregisterProtocolHandlerCaller(JSC::ExecState*, JSNavigator*, JSC::ThrowScope&);

EncodedJSValue JSC_HOST_CALL jsNavigatorPrototypeFunctionUnregisterProtocolHandler(ExecState* state)
{
    return BindingCaller<JSNavigator>::callOperation<jsNavigatorPrototypeFunctionUnregisterProtocolHandlerCaller>(state, "unregisterProtocolHandler");
}

static inline JSC::EncodedJSValue jsNavigatorPrototypeFunctionUnregisterProtocolHandlerCaller(JSC::ExecState* state, JSNavigator* castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 2))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto scheme = convert<IDLDOMString>(*state, state->uncheckedArgument(0), StringConversionConfiguration::Normal);
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto url = convert<IDLDOMString>(*state, state->uncheckedArgument(1), StringConversionConfiguration::Normal);
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    propagateException(*state, throwScope, WebCore::NavigatorContentUtils::unregisterProtocolHandler(impl, WTFMove(scheme), WTFMove(url)));
    return JSValue::encode(jsUndefined());
}

#endif

#if ENABLE(VIBRATION)
static inline JSC::EncodedJSValue jsNavigatorPrototypeFunctionVibrate1Caller(JSC::ExecState*, JSNavigator*, JSC::ThrowScope&);

static inline EncodedJSValue jsNavigatorPrototypeFunctionVibrate1(ExecState* state)
{
    return BindingCaller<JSNavigator>::callOperation<jsNavigatorPrototypeFunctionVibrate1Caller>(state, "vibrate");
}

static inline JSC::EncodedJSValue jsNavigatorPrototypeFunctionVibrate1Caller(JSC::ExecState* state, JSNavigator* castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto pattern = convert<IDLSequence<IDLUnsignedLong>>(*state, state->uncheckedArgument(0));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    return JSValue::encode(toJS<IDLBoolean>(WebCore::NavigatorVibration::vibrate(impl, WTFMove(pattern))));
}

#endif

#if ENABLE(VIBRATION)
static inline JSC::EncodedJSValue jsNavigatorPrototypeFunctionVibrate2Caller(JSC::ExecState*, JSNavigator*, JSC::ThrowScope&);

static inline EncodedJSValue jsNavigatorPrototypeFunctionVibrate2(ExecState* state)
{
    return BindingCaller<JSNavigator>::callOperation<jsNavigatorPrototypeFunctionVibrate2Caller>(state, "vibrate");
}

static inline JSC::EncodedJSValue jsNavigatorPrototypeFunctionVibrate2Caller(JSC::ExecState* state, JSNavigator* castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto time = convert<IDLUnsignedLong>(*state, state->uncheckedArgument(0), IntegerConversionConfiguration::Normal);
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    return JSValue::encode(toJS<IDLBoolean>(WebCore::NavigatorVibration::vibrate(impl, WTFMove(time))));
}

#endif

#if ENABLE(VIBRATION)
EncodedJSValue JSC_HOST_CALL jsNavigatorPrototypeFunctionVibrate(ExecState* state)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    size_t argsCount = std::min<size_t>(1, state->argumentCount());
    if (argsCount == 1) {
        JSValue distinguishingArg = state->uncheckedArgument(0);
#if ENABLE(VIBRATION)
        if (hasIteratorMethod(*state, distinguishingArg))
            return jsNavigatorPrototypeFunctionVibrate1(state);
#endif
#if ENABLE(VIBRATION)
        if (distinguishingArg.isNumber())
            return jsNavigatorPrototypeFunctionVibrate2(state);
#endif
#if ENABLE(VIBRATION)
        return jsNavigatorPrototypeFunctionVibrate2(state);
#endif
    }
    return argsCount < 1 ? throwVMError(state, throwScope, createNotEnoughArgumentsError(state)) : throwVMTypeError(state, throwScope);
}
#endif

bool JSNavigatorOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    auto* jsNavigator = jsCast<JSNavigator*>(handle.slot()->asCell());
    Frame* root = WTF::getPtr(jsNavigator->wrapped().frame());
    if (!root)
        return false;
    return visitor.containsOpaqueRoot(root);
}

void JSNavigatorOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsNavigator = static_cast<JSNavigator*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsNavigator->wrapped(), jsNavigator);
}

#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7Navigator@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore9NavigatorE[]; }
#endif
#endif

JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject* globalObject, Ref<Navigator>&& impl)
{

#if ENABLE(BINDING_INTEGRITY)
    void* actualVTablePointer = *(reinterpret_cast<void**>(impl.ptr()));
#if PLATFORM(WIN)
    void* expectedVTablePointer = reinterpret_cast<void*>(__identifier("??_7Navigator@WebCore@@6B@"));
#else
    void* expectedVTablePointer = &_ZTVN7WebCore9NavigatorE[2];
#if COMPILER(CLANG)
    // If this fails Navigator does not have a vtable, so you need to add the
    // ImplementationLacksVTable attribute to the interface definition
    static_assert(__is_polymorphic(Navigator), "Navigator is not polymorphic");
#endif
#endif
    // If you hit this assertion you either have a use after free bug, or
    // Navigator has subclasses. If Navigator has subclasses that get passed
    // to toJS() we currently require Navigator you to opt out of binding hardening
    // by adding the SkipVTableValidation attribute to the interface IDL definition
    RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    return createWrapper<Navigator>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, Navigator& impl)
{
    return wrap(state, globalObject, impl);
}

Navigator* JSNavigator::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicDowncast<JSNavigator*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}
