/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#pragma once

#if ENABLE(WEB_AUDIO)

#include "JSAudioNode.h"
#include "JSDOMConvert.h"
#include "OscillatorNode.h"

namespace WebCore {

class JSOscillatorNode : public JSAudioNode {
public:
    using Base = JSAudioNode;
    using DOMWrapped = OscillatorNode;
    static JSOscillatorNode* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, Ref<OscillatorNode>&& impl)
    {
        JSOscillatorNode* ptr = new (NotNull, JSC::allocateCell<JSOscillatorNode>(globalObject->vm().heap)) JSOscillatorNode(structure, *globalObject, WTFMove(impl));
        ptr->finishCreation(globalObject->vm());
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::VM&, JSC::JSGlobalObject*);
    static JSC::JSObject* prototype(JSC::VM&, JSC::JSGlobalObject*);

    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

    static JSC::JSValue getConstructor(JSC::VM&, const JSC::JSGlobalObject*);
    static void visitChildren(JSCell*, JSC::SlotVisitor&);

    OscillatorNode& wrapped() const
    {
        return static_cast<OscillatorNode&>(Base::wrapped());
    }
protected:
    JSOscillatorNode(JSC::Structure*, JSDOMGlobalObject&, Ref<OscillatorNode>&&);

    void finishCreation(JSC::VM&);
};

JSC::JSValue toJS(JSC::ExecState*, JSDOMGlobalObject*, OscillatorNode&);
inline JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, OscillatorNode* impl) { return impl ? toJS(state, globalObject, *impl) : JSC::jsNull(); }
JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject*, Ref<OscillatorNode>&&);
inline JSC::JSValue toJSNewlyCreated(JSC::ExecState* state, JSDOMGlobalObject* globalObject, RefPtr<OscillatorNode>&& impl) { return impl ? toJSNewlyCreated(state, globalObject, impl.releaseNonNull()) : JSC::jsNull(); }

template<> struct JSDOMWrapperConverterTraits<OscillatorNode> {
    using WrapperClass = JSOscillatorNode;
    using ToWrappedReturnType = OscillatorNode*;
};
template<> JSC::JSString* convertEnumerationToJS(JSC::ExecState&, OscillatorNode::Type);

template<> std::optional<OscillatorNode::Type> parseEnumeration<OscillatorNode::Type>(JSC::ExecState&, JSC::JSValue);
template<> OscillatorNode::Type convertEnumeration<OscillatorNode::Type>(JSC::ExecState&, JSC::JSValue);
template<> const char* expectedEnumerationValues<OscillatorNode::Type>();


} // namespace WebCore

#endif // ENABLE(WEB_AUDIO)
