/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#pragma once

#if ENABLE(WEB_TIMING)

#include "JSDOMWrapper.h"
#include "PerformanceEntry.h"
#include <wtf/NeverDestroyed.h>

namespace WebCore {

class JSPerformanceEntry : public JSDOMWrapper<PerformanceEntry> {
public:
    using Base = JSDOMWrapper<PerformanceEntry>;
    static JSPerformanceEntry* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, Ref<PerformanceEntry>&& impl)
    {
        JSPerformanceEntry* ptr = new (NotNull, JSC::allocateCell<JSPerformanceEntry>(globalObject->vm().heap)) JSPerformanceEntry(structure, *globalObject, WTFMove(impl));
        ptr->finishCreation(globalObject->vm());
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::VM&, JSC::JSGlobalObject*);
    static JSC::JSObject* prototype(JSC::VM&, JSC::JSGlobalObject*);
    static PerformanceEntry* toWrapped(JSC::VM&, JSC::JSValue);
    static void destroy(JSC::JSCell*);

    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

    static JSC::JSValue getConstructor(JSC::VM&, const JSC::JSGlobalObject*);
    static JSC::JSObject* serialize(JSC::ExecState*, JSPerformanceEntry* thisObject, JSC::ThrowScope&);
protected:
    JSPerformanceEntry(JSC::Structure*, JSDOMGlobalObject&, Ref<PerformanceEntry>&&);

    void finishCreation(JSC::VM&);
};

class JSPerformanceEntryOwner : public JSC::WeakHandleOwner {
public:
    virtual bool isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown>, void* context, JSC::SlotVisitor&);
    virtual void finalize(JSC::Handle<JSC::Unknown>, void* context);
};

inline JSC::WeakHandleOwner* wrapperOwner(DOMWrapperWorld&, PerformanceEntry*)
{
    static NeverDestroyed<JSPerformanceEntryOwner> owner;
    return &owner.get();
}

inline void* wrapperKey(PerformanceEntry* wrappableObject)
{
    return wrappableObject;
}

JSC::JSValue toJS(JSC::ExecState*, JSDOMGlobalObject*, PerformanceEntry&);
inline JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, PerformanceEntry* impl) { return impl ? toJS(state, globalObject, *impl) : JSC::jsNull(); }
JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject*, Ref<PerformanceEntry>&&);
inline JSC::JSValue toJSNewlyCreated(JSC::ExecState* state, JSDOMGlobalObject* globalObject, RefPtr<PerformanceEntry>&& impl) { return impl ? toJSNewlyCreated(state, globalObject, impl.releaseNonNull()) : JSC::jsNull(); }

template<> struct JSDOMWrapperConverterTraits<PerformanceEntry> {
    using WrapperClass = JSPerformanceEntry;
    using ToWrappedReturnType = PerformanceEntry*;
};

} // namespace WebCore

#endif // ENABLE(WEB_TIMING)
