/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(WEB_TIMING)

#include "JSPerformanceResourceTiming.h"

#include "JSDOMBinding.h"
#include "JSDOMBindingCaller.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMConvert.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMWrapperCache.h"
#include <runtime/ObjectConstructor.h>
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

// Functions

JSC::EncodedJSValue JSC_HOST_CALL jsPerformanceResourceTimingPrototypeFunctionToJSON(JSC::ExecState*);

// Attributes

JSC::EncodedJSValue jsPerformanceResourceTimingInitiatorType(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsPerformanceResourceTimingWorkerStart(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsPerformanceResourceTimingRedirectStart(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsPerformanceResourceTimingRedirectEnd(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsPerformanceResourceTimingFetchStart(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsPerformanceResourceTimingDomainLookupStart(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsPerformanceResourceTimingDomainLookupEnd(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsPerformanceResourceTimingConnectStart(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsPerformanceResourceTimingConnectEnd(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsPerformanceResourceTimingSecureConnectionStart(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsPerformanceResourceTimingRequestStart(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsPerformanceResourceTimingResponseStart(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsPerformanceResourceTimingResponseEnd(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsPerformanceResourceTimingConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSPerformanceResourceTimingConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);

class JSPerformanceResourceTimingPrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSPerformanceResourceTimingPrototype* create(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSPerformanceResourceTimingPrototype* ptr = new (NotNull, JSC::allocateCell<JSPerformanceResourceTimingPrototype>(vm.heap)) JSPerformanceResourceTimingPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSPerformanceResourceTimingPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSPerformanceResourceTimingConstructor = JSDOMConstructorNotConstructable<JSPerformanceResourceTiming>;

template<> JSValue JSPerformanceResourceTimingConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    return JSPerformanceEntry::getConstructor(vm, &globalObject);
}

template<> void JSPerformanceResourceTimingConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSPerformanceResourceTiming::prototype(vm, &globalObject), DontDelete | ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(&vm, String(ASCIILiteral("PerformanceResourceTiming"))), ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), ReadOnly | DontEnum);
}

template<> const ClassInfo JSPerformanceResourceTimingConstructor::s_info = { "PerformanceResourceTiming", &Base::s_info, 0, CREATE_METHOD_TABLE(JSPerformanceResourceTimingConstructor) };

/* Hash table for prototype */

static const HashTableValue JSPerformanceResourceTimingPrototypeTableValues[] =
{
    { "constructor", DontEnum, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPerformanceResourceTimingConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSPerformanceResourceTimingConstructor) } },
    { "initiatorType", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPerformanceResourceTimingInitiatorType), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "workerStart", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPerformanceResourceTimingWorkerStart), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "redirectStart", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPerformanceResourceTimingRedirectStart), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "redirectEnd", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPerformanceResourceTimingRedirectEnd), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "fetchStart", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPerformanceResourceTimingFetchStart), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "domainLookupStart", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPerformanceResourceTimingDomainLookupStart), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "domainLookupEnd", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPerformanceResourceTimingDomainLookupEnd), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "connectStart", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPerformanceResourceTimingConnectStart), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "connectEnd", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPerformanceResourceTimingConnectEnd), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "secureConnectionStart", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPerformanceResourceTimingSecureConnectionStart), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "requestStart", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPerformanceResourceTimingRequestStart), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "responseStart", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPerformanceResourceTimingResponseStart), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "responseEnd", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPerformanceResourceTimingResponseEnd), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "toJSON", JSC::Function, NoIntrinsic, { (intptr_t)static_cast<NativeFunction>(jsPerformanceResourceTimingPrototypeFunctionToJSON), (intptr_t) (0) } },
};

const ClassInfo JSPerformanceResourceTimingPrototype::s_info = { "PerformanceResourceTimingPrototype", &Base::s_info, 0, CREATE_METHOD_TABLE(JSPerformanceResourceTimingPrototype) };

void JSPerformanceResourceTimingPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSPerformanceResourceTimingPrototypeTableValues, *this);
}

const ClassInfo JSPerformanceResourceTiming::s_info = { "PerformanceResourceTiming", &Base::s_info, 0, CREATE_METHOD_TABLE(JSPerformanceResourceTiming) };

JSPerformanceResourceTiming::JSPerformanceResourceTiming(Structure* structure, JSDOMGlobalObject& globalObject, Ref<PerformanceResourceTiming>&& impl)
    : JSPerformanceEntry(structure, globalObject, WTFMove(impl))
{
}

void JSPerformanceResourceTiming::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSPerformanceResourceTiming::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSPerformanceResourceTimingPrototype::create(vm, globalObject, JSPerformanceResourceTimingPrototype::createStructure(vm, globalObject, JSPerformanceEntry::prototype(vm, globalObject)));
}

JSObject* JSPerformanceResourceTiming::prototype(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSPerformanceResourceTiming>(vm, globalObject);
}

template<> inline JSPerformanceResourceTiming* BindingCaller<JSPerformanceResourceTiming>::castForAttribute(ExecState& state, EncodedJSValue thisValue)
{
    return jsDynamicDowncast<JSPerformanceResourceTiming*>(state.vm(), JSValue::decode(thisValue));
}

template<> inline JSPerformanceResourceTiming* BindingCaller<JSPerformanceResourceTiming>::castForOperation(ExecState& state)
{
    return jsDynamicDowncast<JSPerformanceResourceTiming*>(state.vm(), state.thisValue());
}

static inline JSValue jsPerformanceResourceTimingInitiatorTypeGetter(ExecState&, JSPerformanceResourceTiming&, ThrowScope& throwScope);

EncodedJSValue jsPerformanceResourceTimingInitiatorType(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSPerformanceResourceTiming>::attribute<jsPerformanceResourceTimingInitiatorTypeGetter>(state, thisValue, "initiatorType");
}

static inline JSValue jsPerformanceResourceTimingInitiatorTypeGetter(ExecState& state, JSPerformanceResourceTiming& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLDOMString>(state, impl.initiatorType());
    return result;
}

static inline JSValue jsPerformanceResourceTimingWorkerStartGetter(ExecState&, JSPerformanceResourceTiming&, ThrowScope& throwScope);

EncodedJSValue jsPerformanceResourceTimingWorkerStart(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSPerformanceResourceTiming>::attribute<jsPerformanceResourceTimingWorkerStartGetter>(state, thisValue, "workerStart");
}

static inline JSValue jsPerformanceResourceTimingWorkerStartGetter(ExecState& state, JSPerformanceResourceTiming& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLDouble>(impl.workerStart());
    return result;
}

static inline JSValue jsPerformanceResourceTimingRedirectStartGetter(ExecState&, JSPerformanceResourceTiming&, ThrowScope& throwScope);

EncodedJSValue jsPerformanceResourceTimingRedirectStart(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSPerformanceResourceTiming>::attribute<jsPerformanceResourceTimingRedirectStartGetter>(state, thisValue, "redirectStart");
}

static inline JSValue jsPerformanceResourceTimingRedirectStartGetter(ExecState& state, JSPerformanceResourceTiming& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLDouble>(impl.redirectStart());
    return result;
}

static inline JSValue jsPerformanceResourceTimingRedirectEndGetter(ExecState&, JSPerformanceResourceTiming&, ThrowScope& throwScope);

EncodedJSValue jsPerformanceResourceTimingRedirectEnd(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSPerformanceResourceTiming>::attribute<jsPerformanceResourceTimingRedirectEndGetter>(state, thisValue, "redirectEnd");
}

static inline JSValue jsPerformanceResourceTimingRedirectEndGetter(ExecState& state, JSPerformanceResourceTiming& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLDouble>(impl.redirectEnd());
    return result;
}

static inline JSValue jsPerformanceResourceTimingFetchStartGetter(ExecState&, JSPerformanceResourceTiming&, ThrowScope& throwScope);

EncodedJSValue jsPerformanceResourceTimingFetchStart(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSPerformanceResourceTiming>::attribute<jsPerformanceResourceTimingFetchStartGetter>(state, thisValue, "fetchStart");
}

static inline JSValue jsPerformanceResourceTimingFetchStartGetter(ExecState& state, JSPerformanceResourceTiming& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLDouble>(impl.fetchStart());
    return result;
}

static inline JSValue jsPerformanceResourceTimingDomainLookupStartGetter(ExecState&, JSPerformanceResourceTiming&, ThrowScope& throwScope);

EncodedJSValue jsPerformanceResourceTimingDomainLookupStart(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSPerformanceResourceTiming>::attribute<jsPerformanceResourceTimingDomainLookupStartGetter>(state, thisValue, "domainLookupStart");
}

static inline JSValue jsPerformanceResourceTimingDomainLookupStartGetter(ExecState& state, JSPerformanceResourceTiming& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLDouble>(impl.domainLookupStart());
    return result;
}

static inline JSValue jsPerformanceResourceTimingDomainLookupEndGetter(ExecState&, JSPerformanceResourceTiming&, ThrowScope& throwScope);

EncodedJSValue jsPerformanceResourceTimingDomainLookupEnd(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSPerformanceResourceTiming>::attribute<jsPerformanceResourceTimingDomainLookupEndGetter>(state, thisValue, "domainLookupEnd");
}

static inline JSValue jsPerformanceResourceTimingDomainLookupEndGetter(ExecState& state, JSPerformanceResourceTiming& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLDouble>(impl.domainLookupEnd());
    return result;
}

static inline JSValue jsPerformanceResourceTimingConnectStartGetter(ExecState&, JSPerformanceResourceTiming&, ThrowScope& throwScope);

EncodedJSValue jsPerformanceResourceTimingConnectStart(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSPerformanceResourceTiming>::attribute<jsPerformanceResourceTimingConnectStartGetter>(state, thisValue, "connectStart");
}

static inline JSValue jsPerformanceResourceTimingConnectStartGetter(ExecState& state, JSPerformanceResourceTiming& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLDouble>(impl.connectStart());
    return result;
}

static inline JSValue jsPerformanceResourceTimingConnectEndGetter(ExecState&, JSPerformanceResourceTiming&, ThrowScope& throwScope);

EncodedJSValue jsPerformanceResourceTimingConnectEnd(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSPerformanceResourceTiming>::attribute<jsPerformanceResourceTimingConnectEndGetter>(state, thisValue, "connectEnd");
}

static inline JSValue jsPerformanceResourceTimingConnectEndGetter(ExecState& state, JSPerformanceResourceTiming& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLDouble>(impl.connectEnd());
    return result;
}

static inline JSValue jsPerformanceResourceTimingSecureConnectionStartGetter(ExecState&, JSPerformanceResourceTiming&, ThrowScope& throwScope);

EncodedJSValue jsPerformanceResourceTimingSecureConnectionStart(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSPerformanceResourceTiming>::attribute<jsPerformanceResourceTimingSecureConnectionStartGetter>(state, thisValue, "secureConnectionStart");
}

static inline JSValue jsPerformanceResourceTimingSecureConnectionStartGetter(ExecState& state, JSPerformanceResourceTiming& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLDouble>(impl.secureConnectionStart());
    return result;
}

static inline JSValue jsPerformanceResourceTimingRequestStartGetter(ExecState&, JSPerformanceResourceTiming&, ThrowScope& throwScope);

EncodedJSValue jsPerformanceResourceTimingRequestStart(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSPerformanceResourceTiming>::attribute<jsPerformanceResourceTimingRequestStartGetter>(state, thisValue, "requestStart");
}

static inline JSValue jsPerformanceResourceTimingRequestStartGetter(ExecState& state, JSPerformanceResourceTiming& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLDouble>(impl.requestStart());
    return result;
}

static inline JSValue jsPerformanceResourceTimingResponseStartGetter(ExecState&, JSPerformanceResourceTiming&, ThrowScope& throwScope);

EncodedJSValue jsPerformanceResourceTimingResponseStart(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSPerformanceResourceTiming>::attribute<jsPerformanceResourceTimingResponseStartGetter>(state, thisValue, "responseStart");
}

static inline JSValue jsPerformanceResourceTimingResponseStartGetter(ExecState& state, JSPerformanceResourceTiming& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLDouble>(impl.responseStart());
    return result;
}

static inline JSValue jsPerformanceResourceTimingResponseEndGetter(ExecState&, JSPerformanceResourceTiming&, ThrowScope& throwScope);

EncodedJSValue jsPerformanceResourceTimingResponseEnd(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSPerformanceResourceTiming>::attribute<jsPerformanceResourceTimingResponseEndGetter>(state, thisValue, "responseEnd");
}

static inline JSValue jsPerformanceResourceTimingResponseEndGetter(ExecState& state, JSPerformanceResourceTiming& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLDouble>(impl.responseEnd());
    return result;
}

EncodedJSValue jsPerformanceResourceTimingConstructor(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    JSPerformanceResourceTimingPrototype* domObject = jsDynamicDowncast<JSPerformanceResourceTimingPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!domObject))
        return throwVMTypeError(state, throwScope);
    return JSValue::encode(JSPerformanceResourceTiming::getConstructor(state->vm(), domObject->globalObject()));
}

bool setJSPerformanceResourceTimingConstructor(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    JSValue value = JSValue::decode(encodedValue);
    JSPerformanceResourceTimingPrototype* domObject = jsDynamicDowncast<JSPerformanceResourceTimingPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!domObject)) {
        throwVMTypeError(state, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return domObject->putDirect(state->vm(), state->propertyNames().constructor, value);
}

JSValue JSPerformanceResourceTiming::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSPerformanceResourceTimingConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

JSC::JSObject* JSPerformanceResourceTiming::serialize(ExecState* state, JSPerformanceResourceTiming* thisObject, ThrowScope& throwScope)
{
    auto& vm = state->vm();
    auto* result = JSPerformanceEntry::serialize(state, thisObject, throwScope);

    auto initiatorTypeValue = jsPerformanceResourceTimingInitiatorTypeGetter(*state, *thisObject, throwScope);
    ASSERT(!throwScope.exception());
    result->putDirect(vm, Identifier::fromString(&vm, "initiatorType"), initiatorTypeValue);

    auto workerStartValue = jsPerformanceResourceTimingWorkerStartGetter(*state, *thisObject, throwScope);
    ASSERT(!throwScope.exception());
    result->putDirect(vm, Identifier::fromString(&vm, "workerStart"), workerStartValue);

    auto redirectStartValue = jsPerformanceResourceTimingRedirectStartGetter(*state, *thisObject, throwScope);
    ASSERT(!throwScope.exception());
    result->putDirect(vm, Identifier::fromString(&vm, "redirectStart"), redirectStartValue);

    auto redirectEndValue = jsPerformanceResourceTimingRedirectEndGetter(*state, *thisObject, throwScope);
    ASSERT(!throwScope.exception());
    result->putDirect(vm, Identifier::fromString(&vm, "redirectEnd"), redirectEndValue);

    auto fetchStartValue = jsPerformanceResourceTimingFetchStartGetter(*state, *thisObject, throwScope);
    ASSERT(!throwScope.exception());
    result->putDirect(vm, Identifier::fromString(&vm, "fetchStart"), fetchStartValue);

    auto domainLookupStartValue = jsPerformanceResourceTimingDomainLookupStartGetter(*state, *thisObject, throwScope);
    ASSERT(!throwScope.exception());
    result->putDirect(vm, Identifier::fromString(&vm, "domainLookupStart"), domainLookupStartValue);

    auto domainLookupEndValue = jsPerformanceResourceTimingDomainLookupEndGetter(*state, *thisObject, throwScope);
    ASSERT(!throwScope.exception());
    result->putDirect(vm, Identifier::fromString(&vm, "domainLookupEnd"), domainLookupEndValue);

    auto connectStartValue = jsPerformanceResourceTimingConnectStartGetter(*state, *thisObject, throwScope);
    ASSERT(!throwScope.exception());
    result->putDirect(vm, Identifier::fromString(&vm, "connectStart"), connectStartValue);

    auto connectEndValue = jsPerformanceResourceTimingConnectEndGetter(*state, *thisObject, throwScope);
    ASSERT(!throwScope.exception());
    result->putDirect(vm, Identifier::fromString(&vm, "connectEnd"), connectEndValue);

    auto secureConnectionStartValue = jsPerformanceResourceTimingSecureConnectionStartGetter(*state, *thisObject, throwScope);
    ASSERT(!throwScope.exception());
    result->putDirect(vm, Identifier::fromString(&vm, "secureConnectionStart"), secureConnectionStartValue);

    auto requestStartValue = jsPerformanceResourceTimingRequestStartGetter(*state, *thisObject, throwScope);
    ASSERT(!throwScope.exception());
    result->putDirect(vm, Identifier::fromString(&vm, "requestStart"), requestStartValue);

    auto responseStartValue = jsPerformanceResourceTimingResponseStartGetter(*state, *thisObject, throwScope);
    ASSERT(!throwScope.exception());
    result->putDirect(vm, Identifier::fromString(&vm, "responseStart"), responseStartValue);

    auto responseEndValue = jsPerformanceResourceTimingResponseEndGetter(*state, *thisObject, throwScope);
    ASSERT(!throwScope.exception());
    result->putDirect(vm, Identifier::fromString(&vm, "responseEnd"), responseEndValue);

    return result;
}

static inline EncodedJSValue jsPerformanceResourceTimingPrototypeFunctionToJSONCaller(ExecState* state, JSPerformanceResourceTiming* thisObject, JSC::ThrowScope& throwScope)
{
    return JSValue::encode(JSPerformanceResourceTiming::serialize(state, thisObject, throwScope));
}

EncodedJSValue JSC_HOST_CALL jsPerformanceResourceTimingPrototypeFunctionToJSON(ExecState* state)
{
    return BindingCaller<JSPerformanceResourceTiming>::callOperation<jsPerformanceResourceTimingPrototypeFunctionToJSONCaller>(state, "toJSON");
}


}

#endif // ENABLE(WEB_TIMING)
