/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(WEB_TIMING)

#include "JSPerformanceTiming.h"

#include "JSDOMBinding.h"
#include "JSDOMBindingCaller.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMConvert.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMWrapperCache.h"
#include <runtime/FunctionPrototype.h>
#include <runtime/ObjectConstructor.h>
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

// Functions

JSC::EncodedJSValue JSC_HOST_CALL jsPerformanceTimingPrototypeFunctionToJSON(JSC::ExecState*);

// Attributes

JSC::EncodedJSValue jsPerformanceTimingNavigationStart(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsPerformanceTimingUnloadEventStart(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsPerformanceTimingUnloadEventEnd(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsPerformanceTimingRedirectStart(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsPerformanceTimingRedirectEnd(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsPerformanceTimingFetchStart(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsPerformanceTimingDomainLookupStart(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsPerformanceTimingDomainLookupEnd(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsPerformanceTimingConnectStart(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsPerformanceTimingConnectEnd(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsPerformanceTimingSecureConnectionStart(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsPerformanceTimingRequestStart(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsPerformanceTimingResponseStart(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsPerformanceTimingResponseEnd(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsPerformanceTimingDomLoading(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsPerformanceTimingDomInteractive(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsPerformanceTimingDomContentLoadedEventStart(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsPerformanceTimingDomContentLoadedEventEnd(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsPerformanceTimingDomComplete(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsPerformanceTimingLoadEventStart(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsPerformanceTimingLoadEventEnd(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsPerformanceTimingConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSPerformanceTimingConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);

class JSPerformanceTimingPrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSPerformanceTimingPrototype* create(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSPerformanceTimingPrototype* ptr = new (NotNull, JSC::allocateCell<JSPerformanceTimingPrototype>(vm.heap)) JSPerformanceTimingPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSPerformanceTimingPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSPerformanceTimingConstructor = JSDOMConstructorNotConstructable<JSPerformanceTiming>;

template<> JSValue JSPerformanceTimingConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.functionPrototype();
}

template<> void JSPerformanceTimingConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSPerformanceTiming::prototype(vm, &globalObject), DontDelete | ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(&vm, String(ASCIILiteral("PerformanceTiming"))), ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), ReadOnly | DontEnum);
}

template<> const ClassInfo JSPerformanceTimingConstructor::s_info = { "PerformanceTiming", &Base::s_info, 0, CREATE_METHOD_TABLE(JSPerformanceTimingConstructor) };

/* Hash table for prototype */

static const HashTableValue JSPerformanceTimingPrototypeTableValues[] =
{
    { "constructor", DontEnum, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPerformanceTimingConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSPerformanceTimingConstructor) } },
    { "navigationStart", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPerformanceTimingNavigationStart), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "unloadEventStart", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPerformanceTimingUnloadEventStart), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "unloadEventEnd", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPerformanceTimingUnloadEventEnd), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "redirectStart", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPerformanceTimingRedirectStart), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "redirectEnd", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPerformanceTimingRedirectEnd), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "fetchStart", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPerformanceTimingFetchStart), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "domainLookupStart", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPerformanceTimingDomainLookupStart), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "domainLookupEnd", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPerformanceTimingDomainLookupEnd), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "connectStart", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPerformanceTimingConnectStart), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "connectEnd", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPerformanceTimingConnectEnd), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "secureConnectionStart", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPerformanceTimingSecureConnectionStart), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "requestStart", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPerformanceTimingRequestStart), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "responseStart", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPerformanceTimingResponseStart), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "responseEnd", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPerformanceTimingResponseEnd), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "domLoading", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPerformanceTimingDomLoading), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "domInteractive", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPerformanceTimingDomInteractive), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "domContentLoadedEventStart", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPerformanceTimingDomContentLoadedEventStart), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "domContentLoadedEventEnd", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPerformanceTimingDomContentLoadedEventEnd), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "domComplete", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPerformanceTimingDomComplete), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "loadEventStart", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPerformanceTimingLoadEventStart), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "loadEventEnd", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPerformanceTimingLoadEventEnd), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "toJSON", JSC::Function, NoIntrinsic, { (intptr_t)static_cast<NativeFunction>(jsPerformanceTimingPrototypeFunctionToJSON), (intptr_t) (0) } },
};

const ClassInfo JSPerformanceTimingPrototype::s_info = { "PerformanceTimingPrototype", &Base::s_info, 0, CREATE_METHOD_TABLE(JSPerformanceTimingPrototype) };

void JSPerformanceTimingPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSPerformanceTimingPrototypeTableValues, *this);
}

const ClassInfo JSPerformanceTiming::s_info = { "PerformanceTiming", &Base::s_info, 0, CREATE_METHOD_TABLE(JSPerformanceTiming) };

JSPerformanceTiming::JSPerformanceTiming(Structure* structure, JSDOMGlobalObject& globalObject, Ref<PerformanceTiming>&& impl)
    : JSDOMWrapper<PerformanceTiming>(structure, globalObject, WTFMove(impl))
{
}

void JSPerformanceTiming::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSPerformanceTiming::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSPerformanceTimingPrototype::create(vm, globalObject, JSPerformanceTimingPrototype::createStructure(vm, globalObject, globalObject->objectPrototype()));
}

JSObject* JSPerformanceTiming::prototype(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSPerformanceTiming>(vm, globalObject);
}

void JSPerformanceTiming::destroy(JSC::JSCell* cell)
{
    JSPerformanceTiming* thisObject = static_cast<JSPerformanceTiming*>(cell);
    thisObject->JSPerformanceTiming::~JSPerformanceTiming();
}

template<> inline JSPerformanceTiming* BindingCaller<JSPerformanceTiming>::castForAttribute(ExecState& state, EncodedJSValue thisValue)
{
    return jsDynamicDowncast<JSPerformanceTiming*>(state.vm(), JSValue::decode(thisValue));
}

template<> inline JSPerformanceTiming* BindingCaller<JSPerformanceTiming>::castForOperation(ExecState& state)
{
    return jsDynamicDowncast<JSPerformanceTiming*>(state.vm(), state.thisValue());
}

static inline JSValue jsPerformanceTimingNavigationStartGetter(ExecState&, JSPerformanceTiming&, ThrowScope& throwScope);

EncodedJSValue jsPerformanceTimingNavigationStart(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSPerformanceTiming>::attribute<jsPerformanceTimingNavigationStartGetter>(state, thisValue, "navigationStart");
}

static inline JSValue jsPerformanceTimingNavigationStartGetter(ExecState& state, JSPerformanceTiming& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnsignedLongLong>(impl.navigationStart());
    return result;
}

static inline JSValue jsPerformanceTimingUnloadEventStartGetter(ExecState&, JSPerformanceTiming&, ThrowScope& throwScope);

EncodedJSValue jsPerformanceTimingUnloadEventStart(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSPerformanceTiming>::attribute<jsPerformanceTimingUnloadEventStartGetter>(state, thisValue, "unloadEventStart");
}

static inline JSValue jsPerformanceTimingUnloadEventStartGetter(ExecState& state, JSPerformanceTiming& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnsignedLongLong>(impl.unloadEventStart());
    return result;
}

static inline JSValue jsPerformanceTimingUnloadEventEndGetter(ExecState&, JSPerformanceTiming&, ThrowScope& throwScope);

EncodedJSValue jsPerformanceTimingUnloadEventEnd(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSPerformanceTiming>::attribute<jsPerformanceTimingUnloadEventEndGetter>(state, thisValue, "unloadEventEnd");
}

static inline JSValue jsPerformanceTimingUnloadEventEndGetter(ExecState& state, JSPerformanceTiming& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnsignedLongLong>(impl.unloadEventEnd());
    return result;
}

static inline JSValue jsPerformanceTimingRedirectStartGetter(ExecState&, JSPerformanceTiming&, ThrowScope& throwScope);

EncodedJSValue jsPerformanceTimingRedirectStart(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSPerformanceTiming>::attribute<jsPerformanceTimingRedirectStartGetter>(state, thisValue, "redirectStart");
}

static inline JSValue jsPerformanceTimingRedirectStartGetter(ExecState& state, JSPerformanceTiming& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnsignedLongLong>(impl.redirectStart());
    return result;
}

static inline JSValue jsPerformanceTimingRedirectEndGetter(ExecState&, JSPerformanceTiming&, ThrowScope& throwScope);

EncodedJSValue jsPerformanceTimingRedirectEnd(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSPerformanceTiming>::attribute<jsPerformanceTimingRedirectEndGetter>(state, thisValue, "redirectEnd");
}

static inline JSValue jsPerformanceTimingRedirectEndGetter(ExecState& state, JSPerformanceTiming& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnsignedLongLong>(impl.redirectEnd());
    return result;
}

static inline JSValue jsPerformanceTimingFetchStartGetter(ExecState&, JSPerformanceTiming&, ThrowScope& throwScope);

EncodedJSValue jsPerformanceTimingFetchStart(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSPerformanceTiming>::attribute<jsPerformanceTimingFetchStartGetter>(state, thisValue, "fetchStart");
}

static inline JSValue jsPerformanceTimingFetchStartGetter(ExecState& state, JSPerformanceTiming& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnsignedLongLong>(impl.fetchStart());
    return result;
}

static inline JSValue jsPerformanceTimingDomainLookupStartGetter(ExecState&, JSPerformanceTiming&, ThrowScope& throwScope);

EncodedJSValue jsPerformanceTimingDomainLookupStart(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSPerformanceTiming>::attribute<jsPerformanceTimingDomainLookupStartGetter>(state, thisValue, "domainLookupStart");
}

static inline JSValue jsPerformanceTimingDomainLookupStartGetter(ExecState& state, JSPerformanceTiming& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnsignedLongLong>(impl.domainLookupStart());
    return result;
}

static inline JSValue jsPerformanceTimingDomainLookupEndGetter(ExecState&, JSPerformanceTiming&, ThrowScope& throwScope);

EncodedJSValue jsPerformanceTimingDomainLookupEnd(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSPerformanceTiming>::attribute<jsPerformanceTimingDomainLookupEndGetter>(state, thisValue, "domainLookupEnd");
}

static inline JSValue jsPerformanceTimingDomainLookupEndGetter(ExecState& state, JSPerformanceTiming& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnsignedLongLong>(impl.domainLookupEnd());
    return result;
}

static inline JSValue jsPerformanceTimingConnectStartGetter(ExecState&, JSPerformanceTiming&, ThrowScope& throwScope);

EncodedJSValue jsPerformanceTimingConnectStart(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSPerformanceTiming>::attribute<jsPerformanceTimingConnectStartGetter>(state, thisValue, "connectStart");
}

static inline JSValue jsPerformanceTimingConnectStartGetter(ExecState& state, JSPerformanceTiming& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnsignedLongLong>(impl.connectStart());
    return result;
}

static inline JSValue jsPerformanceTimingConnectEndGetter(ExecState&, JSPerformanceTiming&, ThrowScope& throwScope);

EncodedJSValue jsPerformanceTimingConnectEnd(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSPerformanceTiming>::attribute<jsPerformanceTimingConnectEndGetter>(state, thisValue, "connectEnd");
}

static inline JSValue jsPerformanceTimingConnectEndGetter(ExecState& state, JSPerformanceTiming& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnsignedLongLong>(impl.connectEnd());
    return result;
}

static inline JSValue jsPerformanceTimingSecureConnectionStartGetter(ExecState&, JSPerformanceTiming&, ThrowScope& throwScope);

EncodedJSValue jsPerformanceTimingSecureConnectionStart(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSPerformanceTiming>::attribute<jsPerformanceTimingSecureConnectionStartGetter>(state, thisValue, "secureConnectionStart");
}

static inline JSValue jsPerformanceTimingSecureConnectionStartGetter(ExecState& state, JSPerformanceTiming& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnsignedLongLong>(impl.secureConnectionStart());
    return result;
}

static inline JSValue jsPerformanceTimingRequestStartGetter(ExecState&, JSPerformanceTiming&, ThrowScope& throwScope);

EncodedJSValue jsPerformanceTimingRequestStart(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSPerformanceTiming>::attribute<jsPerformanceTimingRequestStartGetter>(state, thisValue, "requestStart");
}

static inline JSValue jsPerformanceTimingRequestStartGetter(ExecState& state, JSPerformanceTiming& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnsignedLongLong>(impl.requestStart());
    return result;
}

static inline JSValue jsPerformanceTimingResponseStartGetter(ExecState&, JSPerformanceTiming&, ThrowScope& throwScope);

EncodedJSValue jsPerformanceTimingResponseStart(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSPerformanceTiming>::attribute<jsPerformanceTimingResponseStartGetter>(state, thisValue, "responseStart");
}

static inline JSValue jsPerformanceTimingResponseStartGetter(ExecState& state, JSPerformanceTiming& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnsignedLongLong>(impl.responseStart());
    return result;
}

static inline JSValue jsPerformanceTimingResponseEndGetter(ExecState&, JSPerformanceTiming&, ThrowScope& throwScope);

EncodedJSValue jsPerformanceTimingResponseEnd(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSPerformanceTiming>::attribute<jsPerformanceTimingResponseEndGetter>(state, thisValue, "responseEnd");
}

static inline JSValue jsPerformanceTimingResponseEndGetter(ExecState& state, JSPerformanceTiming& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnsignedLongLong>(impl.responseEnd());
    return result;
}

static inline JSValue jsPerformanceTimingDomLoadingGetter(ExecState&, JSPerformanceTiming&, ThrowScope& throwScope);

EncodedJSValue jsPerformanceTimingDomLoading(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSPerformanceTiming>::attribute<jsPerformanceTimingDomLoadingGetter>(state, thisValue, "domLoading");
}

static inline JSValue jsPerformanceTimingDomLoadingGetter(ExecState& state, JSPerformanceTiming& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnsignedLongLong>(impl.domLoading());
    return result;
}

static inline JSValue jsPerformanceTimingDomInteractiveGetter(ExecState&, JSPerformanceTiming&, ThrowScope& throwScope);

EncodedJSValue jsPerformanceTimingDomInteractive(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSPerformanceTiming>::attribute<jsPerformanceTimingDomInteractiveGetter>(state, thisValue, "domInteractive");
}

static inline JSValue jsPerformanceTimingDomInteractiveGetter(ExecState& state, JSPerformanceTiming& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnsignedLongLong>(impl.domInteractive());
    return result;
}

static inline JSValue jsPerformanceTimingDomContentLoadedEventStartGetter(ExecState&, JSPerformanceTiming&, ThrowScope& throwScope);

EncodedJSValue jsPerformanceTimingDomContentLoadedEventStart(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSPerformanceTiming>::attribute<jsPerformanceTimingDomContentLoadedEventStartGetter>(state, thisValue, "domContentLoadedEventStart");
}

static inline JSValue jsPerformanceTimingDomContentLoadedEventStartGetter(ExecState& state, JSPerformanceTiming& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnsignedLongLong>(impl.domContentLoadedEventStart());
    return result;
}

static inline JSValue jsPerformanceTimingDomContentLoadedEventEndGetter(ExecState&, JSPerformanceTiming&, ThrowScope& throwScope);

EncodedJSValue jsPerformanceTimingDomContentLoadedEventEnd(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSPerformanceTiming>::attribute<jsPerformanceTimingDomContentLoadedEventEndGetter>(state, thisValue, "domContentLoadedEventEnd");
}

static inline JSValue jsPerformanceTimingDomContentLoadedEventEndGetter(ExecState& state, JSPerformanceTiming& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnsignedLongLong>(impl.domContentLoadedEventEnd());
    return result;
}

static inline JSValue jsPerformanceTimingDomCompleteGetter(ExecState&, JSPerformanceTiming&, ThrowScope& throwScope);

EncodedJSValue jsPerformanceTimingDomComplete(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSPerformanceTiming>::attribute<jsPerformanceTimingDomCompleteGetter>(state, thisValue, "domComplete");
}

static inline JSValue jsPerformanceTimingDomCompleteGetter(ExecState& state, JSPerformanceTiming& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnsignedLongLong>(impl.domComplete());
    return result;
}

static inline JSValue jsPerformanceTimingLoadEventStartGetter(ExecState&, JSPerformanceTiming&, ThrowScope& throwScope);

EncodedJSValue jsPerformanceTimingLoadEventStart(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSPerformanceTiming>::attribute<jsPerformanceTimingLoadEventStartGetter>(state, thisValue, "loadEventStart");
}

static inline JSValue jsPerformanceTimingLoadEventStartGetter(ExecState& state, JSPerformanceTiming& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnsignedLongLong>(impl.loadEventStart());
    return result;
}

static inline JSValue jsPerformanceTimingLoadEventEndGetter(ExecState&, JSPerformanceTiming&, ThrowScope& throwScope);

EncodedJSValue jsPerformanceTimingLoadEventEnd(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSPerformanceTiming>::attribute<jsPerformanceTimingLoadEventEndGetter>(state, thisValue, "loadEventEnd");
}

static inline JSValue jsPerformanceTimingLoadEventEndGetter(ExecState& state, JSPerformanceTiming& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnsignedLongLong>(impl.loadEventEnd());
    return result;
}

EncodedJSValue jsPerformanceTimingConstructor(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    JSPerformanceTimingPrototype* domObject = jsDynamicDowncast<JSPerformanceTimingPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!domObject))
        return throwVMTypeError(state, throwScope);
    return JSValue::encode(JSPerformanceTiming::getConstructor(state->vm(), domObject->globalObject()));
}

bool setJSPerformanceTimingConstructor(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    JSValue value = JSValue::decode(encodedValue);
    JSPerformanceTimingPrototype* domObject = jsDynamicDowncast<JSPerformanceTimingPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!domObject)) {
        throwVMTypeError(state, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return domObject->putDirect(state->vm(), state->propertyNames().constructor, value);
}

JSValue JSPerformanceTiming::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSPerformanceTimingConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

JSC::JSObject* JSPerformanceTiming::serialize(ExecState* state, JSPerformanceTiming* thisObject, ThrowScope& throwScope)
{
    auto& vm = state->vm();
    auto* result = constructEmptyObject(state);

    auto navigationStartValue = jsPerformanceTimingNavigationStartGetter(*state, *thisObject, throwScope);
    ASSERT(!throwScope.exception());
    result->putDirect(vm, Identifier::fromString(&vm, "navigationStart"), navigationStartValue);

    auto unloadEventStartValue = jsPerformanceTimingUnloadEventStartGetter(*state, *thisObject, throwScope);
    ASSERT(!throwScope.exception());
    result->putDirect(vm, Identifier::fromString(&vm, "unloadEventStart"), unloadEventStartValue);

    auto unloadEventEndValue = jsPerformanceTimingUnloadEventEndGetter(*state, *thisObject, throwScope);
    ASSERT(!throwScope.exception());
    result->putDirect(vm, Identifier::fromString(&vm, "unloadEventEnd"), unloadEventEndValue);

    auto redirectStartValue = jsPerformanceTimingRedirectStartGetter(*state, *thisObject, throwScope);
    ASSERT(!throwScope.exception());
    result->putDirect(vm, Identifier::fromString(&vm, "redirectStart"), redirectStartValue);

    auto redirectEndValue = jsPerformanceTimingRedirectEndGetter(*state, *thisObject, throwScope);
    ASSERT(!throwScope.exception());
    result->putDirect(vm, Identifier::fromString(&vm, "redirectEnd"), redirectEndValue);

    auto fetchStartValue = jsPerformanceTimingFetchStartGetter(*state, *thisObject, throwScope);
    ASSERT(!throwScope.exception());
    result->putDirect(vm, Identifier::fromString(&vm, "fetchStart"), fetchStartValue);

    auto domainLookupStartValue = jsPerformanceTimingDomainLookupStartGetter(*state, *thisObject, throwScope);
    ASSERT(!throwScope.exception());
    result->putDirect(vm, Identifier::fromString(&vm, "domainLookupStart"), domainLookupStartValue);

    auto domainLookupEndValue = jsPerformanceTimingDomainLookupEndGetter(*state, *thisObject, throwScope);
    ASSERT(!throwScope.exception());
    result->putDirect(vm, Identifier::fromString(&vm, "domainLookupEnd"), domainLookupEndValue);

    auto connectStartValue = jsPerformanceTimingConnectStartGetter(*state, *thisObject, throwScope);
    ASSERT(!throwScope.exception());
    result->putDirect(vm, Identifier::fromString(&vm, "connectStart"), connectStartValue);

    auto connectEndValue = jsPerformanceTimingConnectEndGetter(*state, *thisObject, throwScope);
    ASSERT(!throwScope.exception());
    result->putDirect(vm, Identifier::fromString(&vm, "connectEnd"), connectEndValue);

    auto secureConnectionStartValue = jsPerformanceTimingSecureConnectionStartGetter(*state, *thisObject, throwScope);
    ASSERT(!throwScope.exception());
    result->putDirect(vm, Identifier::fromString(&vm, "secureConnectionStart"), secureConnectionStartValue);

    auto requestStartValue = jsPerformanceTimingRequestStartGetter(*state, *thisObject, throwScope);
    ASSERT(!throwScope.exception());
    result->putDirect(vm, Identifier::fromString(&vm, "requestStart"), requestStartValue);

    auto responseStartValue = jsPerformanceTimingResponseStartGetter(*state, *thisObject, throwScope);
    ASSERT(!throwScope.exception());
    result->putDirect(vm, Identifier::fromString(&vm, "responseStart"), responseStartValue);

    auto responseEndValue = jsPerformanceTimingResponseEndGetter(*state, *thisObject, throwScope);
    ASSERT(!throwScope.exception());
    result->putDirect(vm, Identifier::fromString(&vm, "responseEnd"), responseEndValue);

    auto domLoadingValue = jsPerformanceTimingDomLoadingGetter(*state, *thisObject, throwScope);
    ASSERT(!throwScope.exception());
    result->putDirect(vm, Identifier::fromString(&vm, "domLoading"), domLoadingValue);

    auto domInteractiveValue = jsPerformanceTimingDomInteractiveGetter(*state, *thisObject, throwScope);
    ASSERT(!throwScope.exception());
    result->putDirect(vm, Identifier::fromString(&vm, "domInteractive"), domInteractiveValue);

    auto domContentLoadedEventStartValue = jsPerformanceTimingDomContentLoadedEventStartGetter(*state, *thisObject, throwScope);
    ASSERT(!throwScope.exception());
    result->putDirect(vm, Identifier::fromString(&vm, "domContentLoadedEventStart"), domContentLoadedEventStartValue);

    auto domContentLoadedEventEndValue = jsPerformanceTimingDomContentLoadedEventEndGetter(*state, *thisObject, throwScope);
    ASSERT(!throwScope.exception());
    result->putDirect(vm, Identifier::fromString(&vm, "domContentLoadedEventEnd"), domContentLoadedEventEndValue);

    auto domCompleteValue = jsPerformanceTimingDomCompleteGetter(*state, *thisObject, throwScope);
    ASSERT(!throwScope.exception());
    result->putDirect(vm, Identifier::fromString(&vm, "domComplete"), domCompleteValue);

    auto loadEventStartValue = jsPerformanceTimingLoadEventStartGetter(*state, *thisObject, throwScope);
    ASSERT(!throwScope.exception());
    result->putDirect(vm, Identifier::fromString(&vm, "loadEventStart"), loadEventStartValue);

    auto loadEventEndValue = jsPerformanceTimingLoadEventEndGetter(*state, *thisObject, throwScope);
    ASSERT(!throwScope.exception());
    result->putDirect(vm, Identifier::fromString(&vm, "loadEventEnd"), loadEventEndValue);

    return result;
}

static inline EncodedJSValue jsPerformanceTimingPrototypeFunctionToJSONCaller(ExecState* state, JSPerformanceTiming* thisObject, JSC::ThrowScope& throwScope)
{
    return JSValue::encode(JSPerformanceTiming::serialize(state, thisObject, throwScope));
}

EncodedJSValue JSC_HOST_CALL jsPerformanceTimingPrototypeFunctionToJSON(ExecState* state)
{
    return BindingCaller<JSPerformanceTiming>::callOperation<jsPerformanceTimingPrototypeFunctionToJSONCaller>(state, "toJSON");
}

bool JSPerformanceTimingOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    return false;
}

void JSPerformanceTimingOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsPerformanceTiming = static_cast<JSPerformanceTiming*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsPerformanceTiming->wrapped(), jsPerformanceTiming);
}

#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7PerformanceTiming@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore17PerformanceTimingE[]; }
#endif
#endif

JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject* globalObject, Ref<PerformanceTiming>&& impl)
{

#if ENABLE(BINDING_INTEGRITY)
    void* actualVTablePointer = *(reinterpret_cast<void**>(impl.ptr()));
#if PLATFORM(WIN)
    void* expectedVTablePointer = reinterpret_cast<void*>(__identifier("??_7PerformanceTiming@WebCore@@6B@"));
#else
    void* expectedVTablePointer = &_ZTVN7WebCore17PerformanceTimingE[2];
#if COMPILER(CLANG)
    // If this fails PerformanceTiming does not have a vtable, so you need to add the
    // ImplementationLacksVTable attribute to the interface definition
    static_assert(__is_polymorphic(PerformanceTiming), "PerformanceTiming is not polymorphic");
#endif
#endif
    // If you hit this assertion you either have a use after free bug, or
    // PerformanceTiming has subclasses. If PerformanceTiming has subclasses that get passed
    // to toJS() we currently require PerformanceTiming you to opt out of binding hardening
    // by adding the SkipVTableValidation attribute to the interface IDL definition
    RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    return createWrapper<PerformanceTiming>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, PerformanceTiming& impl)
{
    return wrap(state, globalObject, impl);
}

PerformanceTiming* JSPerformanceTiming::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicDowncast<JSPerformanceTiming*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}

#endif // ENABLE(WEB_TIMING)
