/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSPositionOptions.h"


using namespace JSC;

namespace WebCore {

template<> PositionOptions convertDictionary<PositionOptions>(ExecState& state, JSValue value)
{
    VM& vm = state.vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&state, throwScope);
        return { };
    }
    if (UNLIKELY(object && object->type() == RegExpObjectType)) {
        throwTypeError(&state, throwScope);
        return { };
    }
    PositionOptions result;
    JSValue enableHighAccuracyValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "enableHighAccuracy"));
    if (!enableHighAccuracyValue.isUndefined()) {
        result.enableHighAccuracy = convert<IDLBoolean>(state, enableHighAccuracyValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.enableHighAccuracy = false;
    JSValue maximumAgeValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "maximumAge"));
    if (!maximumAgeValue.isUndefined()) {
        result.maximumAge = convert<IDLUnsignedLong>(state, maximumAgeValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.maximumAge = 0;
    JSValue timeoutValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "timeout"));
    if (!timeoutValue.isUndefined()) {
        result.timeout = convert<IDLUnsignedLong>(state, timeoutValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.timeout = 0xFFFFFFFF;
    return result;
}

} // namespace WebCore
