/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSStaticRange.h"

#include "JSDOMBinding.h"
#include "JSDOMBindingCaller.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMConvert.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMWrapperCache.h"
#include "JSNode.h"
#include <runtime/FunctionPrototype.h>
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

// Attributes

JSC::EncodedJSValue jsStaticRangeStartOffset(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsStaticRangeEndOffset(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsStaticRangeStartContainer(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsStaticRangeEndContainer(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsStaticRangeCollapsed(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsStaticRangeConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSStaticRangeConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);

class JSStaticRangePrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSStaticRangePrototype* create(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSStaticRangePrototype* ptr = new (NotNull, JSC::allocateCell<JSStaticRangePrototype>(vm.heap)) JSStaticRangePrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSStaticRangePrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSStaticRangeConstructor = JSDOMConstructorNotConstructable<JSStaticRange>;

template<> JSValue JSStaticRangeConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.functionPrototype();
}

template<> void JSStaticRangeConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSStaticRange::prototype(vm, &globalObject), DontDelete | ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(&vm, String(ASCIILiteral("StaticRange"))), ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), ReadOnly | DontEnum);
}

template<> const ClassInfo JSStaticRangeConstructor::s_info = { "StaticRange", &Base::s_info, 0, CREATE_METHOD_TABLE(JSStaticRangeConstructor) };

/* Hash table for prototype */

static const HashTableValue JSStaticRangePrototypeTableValues[] =
{
    { "constructor", DontEnum, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsStaticRangeConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSStaticRangeConstructor) } },
    { "startOffset", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsStaticRangeStartOffset), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "endOffset", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsStaticRangeEndOffset), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "startContainer", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsStaticRangeStartContainer), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "endContainer", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsStaticRangeEndContainer), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "collapsed", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsStaticRangeCollapsed), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
};

const ClassInfo JSStaticRangePrototype::s_info = { "StaticRangePrototype", &Base::s_info, 0, CREATE_METHOD_TABLE(JSStaticRangePrototype) };

void JSStaticRangePrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSStaticRangePrototypeTableValues, *this);
}

const ClassInfo JSStaticRange::s_info = { "StaticRange", &Base::s_info, 0, CREATE_METHOD_TABLE(JSStaticRange) };

JSStaticRange::JSStaticRange(Structure* structure, JSDOMGlobalObject& globalObject, Ref<StaticRange>&& impl)
    : JSDOMWrapper<StaticRange>(structure, globalObject, WTFMove(impl))
{
}

void JSStaticRange::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSStaticRange::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSStaticRangePrototype::create(vm, globalObject, JSStaticRangePrototype::createStructure(vm, globalObject, globalObject->objectPrototype()));
}

JSObject* JSStaticRange::prototype(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSStaticRange>(vm, globalObject);
}

void JSStaticRange::destroy(JSC::JSCell* cell)
{
    JSStaticRange* thisObject = static_cast<JSStaticRange*>(cell);
    thisObject->JSStaticRange::~JSStaticRange();
}

template<> inline JSStaticRange* BindingCaller<JSStaticRange>::castForAttribute(ExecState& state, EncodedJSValue thisValue)
{
    return jsDynamicDowncast<JSStaticRange*>(state.vm(), JSValue::decode(thisValue));
}

static inline JSValue jsStaticRangeStartOffsetGetter(ExecState&, JSStaticRange&, ThrowScope& throwScope);

EncodedJSValue jsStaticRangeStartOffset(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSStaticRange>::attribute<jsStaticRangeStartOffsetGetter>(state, thisValue, "startOffset");
}

static inline JSValue jsStaticRangeStartOffsetGetter(ExecState& state, JSStaticRange& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnsignedLong>(impl.startOffset());
    return result;
}

static inline JSValue jsStaticRangeEndOffsetGetter(ExecState&, JSStaticRange&, ThrowScope& throwScope);

EncodedJSValue jsStaticRangeEndOffset(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSStaticRange>::attribute<jsStaticRangeEndOffsetGetter>(state, thisValue, "endOffset");
}

static inline JSValue jsStaticRangeEndOffsetGetter(ExecState& state, JSStaticRange& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnsignedLong>(impl.endOffset());
    return result;
}

static inline JSValue jsStaticRangeStartContainerGetter(ExecState&, JSStaticRange&, ThrowScope& throwScope);

EncodedJSValue jsStaticRangeStartContainer(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSStaticRange>::attribute<jsStaticRangeStartContainerGetter>(state, thisValue, "startContainer");
}

static inline JSValue jsStaticRangeStartContainerGetter(ExecState& state, JSStaticRange& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLInterface<Node>>(state, *thisObject.globalObject(), impl.startContainer());
    return result;
}

static inline JSValue jsStaticRangeEndContainerGetter(ExecState&, JSStaticRange&, ThrowScope& throwScope);

EncodedJSValue jsStaticRangeEndContainer(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSStaticRange>::attribute<jsStaticRangeEndContainerGetter>(state, thisValue, "endContainer");
}

static inline JSValue jsStaticRangeEndContainerGetter(ExecState& state, JSStaticRange& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLInterface<Node>>(state, *thisObject.globalObject(), impl.endContainer());
    return result;
}

static inline JSValue jsStaticRangeCollapsedGetter(ExecState&, JSStaticRange&, ThrowScope& throwScope);

EncodedJSValue jsStaticRangeCollapsed(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSStaticRange>::attribute<jsStaticRangeCollapsedGetter>(state, thisValue, "collapsed");
}

static inline JSValue jsStaticRangeCollapsedGetter(ExecState& state, JSStaticRange& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLBoolean>(impl.collapsed());
    return result;
}

EncodedJSValue jsStaticRangeConstructor(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    JSStaticRangePrototype* domObject = jsDynamicDowncast<JSStaticRangePrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!domObject))
        return throwVMTypeError(state, throwScope);
    return JSValue::encode(JSStaticRange::getConstructor(state->vm(), domObject->globalObject()));
}

bool setJSStaticRangeConstructor(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    JSValue value = JSValue::decode(encodedValue);
    JSStaticRangePrototype* domObject = jsDynamicDowncast<JSStaticRangePrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!domObject)) {
        throwVMTypeError(state, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return domObject->putDirect(state->vm(), state->propertyNames().constructor, value);
}

JSValue JSStaticRange::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSStaticRangeConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

bool JSStaticRangeOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    return false;
}

void JSStaticRangeOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsStaticRange = static_cast<JSStaticRange*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsStaticRange->wrapped(), jsStaticRange);
}

JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject* globalObject, Ref<StaticRange>&& impl)
{
#if COMPILER(CLANG)
    // If you hit this failure the interface definition has the ImplementationLacksVTable
    // attribute. You should remove that attribute. If the class has subclasses
    // that may be passed through this toJS() function you should use the SkipVTableValidation
    // attribute to StaticRange.
    static_assert(!__is_polymorphic(StaticRange), "StaticRange is polymorphic but the IDL claims it is not");
#endif
    return createWrapper<StaticRange>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, StaticRange& impl)
{
    return wrap(state, globalObject, impl);
}

StaticRange* JSStaticRange::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicDowncast<JSStaticRange*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}
