/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSStorageEvent.h"

#include "JSDOMBinding.h"
#include "JSDOMBindingCaller.h"
#include "JSDOMConstructor.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMWrapperCache.h"
#include "JSStorage.h"
#include <runtime/Error.h>
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

template<> StorageEvent::Init convertDictionary<StorageEvent::Init>(ExecState& state, JSValue value)
{
    VM& vm = state.vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&state, throwScope);
        return { };
    }
    if (UNLIKELY(object && object->type() == RegExpObjectType)) {
        throwTypeError(&state, throwScope);
        return { };
    }
    StorageEvent::Init result;
    JSValue bubblesValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "bubbles"));
    if (!bubblesValue.isUndefined()) {
        result.bubbles = convert<IDLBoolean>(state, bubblesValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.bubbles = false;
    JSValue cancelableValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "cancelable"));
    if (!cancelableValue.isUndefined()) {
        result.cancelable = convert<IDLBoolean>(state, cancelableValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.cancelable = false;
    JSValue composedValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "composed"));
    if (!composedValue.isUndefined()) {
        result.composed = convert<IDLBoolean>(state, composedValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.composed = false;
    JSValue keyValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "key"));
    if (!keyValue.isUndefined()) {
        result.key = convert<IDLNullable<IDLDOMString>>(state, keyValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.key = String();
    JSValue newValueValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "newValue"));
    if (!newValueValue.isUndefined()) {
        result.newValue = convert<IDLNullable<IDLDOMString>>(state, newValueValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.newValue = String();
    JSValue oldValueValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "oldValue"));
    if (!oldValueValue.isUndefined()) {
        result.oldValue = convert<IDLNullable<IDLDOMString>>(state, oldValueValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.oldValue = String();
    JSValue storageAreaValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "storageArea"));
    if (!storageAreaValue.isUndefined()) {
        result.storageArea = convert<IDLNullable<IDLInterface<Storage>>>(state, storageAreaValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.storageArea = nullptr;
    JSValue urlValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "url"));
    if (!urlValue.isUndefined()) {
        result.url = convert<IDLUSVString>(state, urlValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.url = emptyString();
    return result;
}

// Functions

JSC::EncodedJSValue JSC_HOST_CALL jsStorageEventPrototypeFunctionInitStorageEvent(JSC::ExecState*);

// Attributes

JSC::EncodedJSValue jsStorageEventKey(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsStorageEventOldValue(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsStorageEventNewValue(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsStorageEventUrl(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsStorageEventStorageArea(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsStorageEventConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSStorageEventConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);

class JSStorageEventPrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSStorageEventPrototype* create(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSStorageEventPrototype* ptr = new (NotNull, JSC::allocateCell<JSStorageEventPrototype>(vm.heap)) JSStorageEventPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSStorageEventPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSStorageEventConstructor = JSDOMConstructor<JSStorageEvent>;

template<> EncodedJSValue JSC_HOST_CALL JSStorageEventConstructor::construct(ExecState* state)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    auto* castedThis = jsCast<JSStorageEventConstructor*>(state->jsCallee());
    ASSERT(castedThis);
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto type = convert<IDLDOMString>(*state, state->uncheckedArgument(0), StringConversionConfiguration::Normal);
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto eventInitDict = convert<IDLDictionary<StorageEvent::Init>>(*state, state->argument(1));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto object = StorageEvent::create(WTFMove(type), WTFMove(eventInitDict));
    return JSValue::encode(toJSNewlyCreated<IDLInterface<StorageEvent>>(*state, *castedThis->globalObject(), WTFMove(object)));
}

template<> JSValue JSStorageEventConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    return JSEvent::getConstructor(vm, &globalObject);
}

template<> void JSStorageEventConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSStorageEvent::prototype(vm, &globalObject), DontDelete | ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(&vm, String(ASCIILiteral("StorageEvent"))), ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(1), ReadOnly | DontEnum);
}

template<> const ClassInfo JSStorageEventConstructor::s_info = { "StorageEvent", &Base::s_info, 0, CREATE_METHOD_TABLE(JSStorageEventConstructor) };

/* Hash table for prototype */

static const HashTableValue JSStorageEventPrototypeTableValues[] =
{
    { "constructor", DontEnum, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsStorageEventConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSStorageEventConstructor) } },
    { "key", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsStorageEventKey), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "oldValue", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsStorageEventOldValue), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "newValue", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsStorageEventNewValue), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "url", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsStorageEventUrl), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "storageArea", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsStorageEventStorageArea), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "initStorageEvent", JSC::Function, NoIntrinsic, { (intptr_t)static_cast<NativeFunction>(jsStorageEventPrototypeFunctionInitStorageEvent), (intptr_t) (0) } },
};

const ClassInfo JSStorageEventPrototype::s_info = { "StorageEventPrototype", &Base::s_info, 0, CREATE_METHOD_TABLE(JSStorageEventPrototype) };

void JSStorageEventPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSStorageEventPrototypeTableValues, *this);
}

const ClassInfo JSStorageEvent::s_info = { "StorageEvent", &Base::s_info, 0, CREATE_METHOD_TABLE(JSStorageEvent) };

JSStorageEvent::JSStorageEvent(Structure* structure, JSDOMGlobalObject& globalObject, Ref<StorageEvent>&& impl)
    : JSEvent(structure, globalObject, WTFMove(impl))
{
}

void JSStorageEvent::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSStorageEvent::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSStorageEventPrototype::create(vm, globalObject, JSStorageEventPrototype::createStructure(vm, globalObject, JSEvent::prototype(vm, globalObject)));
}

JSObject* JSStorageEvent::prototype(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSStorageEvent>(vm, globalObject);
}

template<> inline JSStorageEvent* BindingCaller<JSStorageEvent>::castForAttribute(ExecState& state, EncodedJSValue thisValue)
{
    return jsDynamicDowncast<JSStorageEvent*>(state.vm(), JSValue::decode(thisValue));
}

template<> inline JSStorageEvent* BindingCaller<JSStorageEvent>::castForOperation(ExecState& state)
{
    return jsDynamicDowncast<JSStorageEvent*>(state.vm(), state.thisValue());
}

static inline JSValue jsStorageEventKeyGetter(ExecState&, JSStorageEvent&, ThrowScope& throwScope);

EncodedJSValue jsStorageEventKey(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSStorageEvent>::attribute<jsStorageEventKeyGetter>(state, thisValue, "key");
}

static inline JSValue jsStorageEventKeyGetter(ExecState& state, JSStorageEvent& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLNullable<IDLDOMString>>(state, impl.key());
    return result;
}

static inline JSValue jsStorageEventOldValueGetter(ExecState&, JSStorageEvent&, ThrowScope& throwScope);

EncodedJSValue jsStorageEventOldValue(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSStorageEvent>::attribute<jsStorageEventOldValueGetter>(state, thisValue, "oldValue");
}

static inline JSValue jsStorageEventOldValueGetter(ExecState& state, JSStorageEvent& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLNullable<IDLDOMString>>(state, impl.oldValue());
    return result;
}

static inline JSValue jsStorageEventNewValueGetter(ExecState&, JSStorageEvent&, ThrowScope& throwScope);

EncodedJSValue jsStorageEventNewValue(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSStorageEvent>::attribute<jsStorageEventNewValueGetter>(state, thisValue, "newValue");
}

static inline JSValue jsStorageEventNewValueGetter(ExecState& state, JSStorageEvent& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLNullable<IDLDOMString>>(state, impl.newValue());
    return result;
}

static inline JSValue jsStorageEventUrlGetter(ExecState&, JSStorageEvent&, ThrowScope& throwScope);

EncodedJSValue jsStorageEventUrl(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSStorageEvent>::attribute<jsStorageEventUrlGetter>(state, thisValue, "url");
}

static inline JSValue jsStorageEventUrlGetter(ExecState& state, JSStorageEvent& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUSVString>(state, impl.url());
    return result;
}

static inline JSValue jsStorageEventStorageAreaGetter(ExecState&, JSStorageEvent&, ThrowScope& throwScope);

EncodedJSValue jsStorageEventStorageArea(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSStorageEvent>::attribute<jsStorageEventStorageAreaGetter>(state, thisValue, "storageArea");
}

static inline JSValue jsStorageEventStorageAreaGetter(ExecState& state, JSStorageEvent& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLNullable<IDLInterface<Storage>>>(state, *thisObject.globalObject(), impl.storageArea());
    return result;
}

EncodedJSValue jsStorageEventConstructor(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    JSStorageEventPrototype* domObject = jsDynamicDowncast<JSStorageEventPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!domObject))
        return throwVMTypeError(state, throwScope);
    return JSValue::encode(JSStorageEvent::getConstructor(state->vm(), domObject->globalObject()));
}

bool setJSStorageEventConstructor(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    JSValue value = JSValue::decode(encodedValue);
    JSStorageEventPrototype* domObject = jsDynamicDowncast<JSStorageEventPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!domObject)) {
        throwVMTypeError(state, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return domObject->putDirect(state->vm(), state->propertyNames().constructor, value);
}

JSValue JSStorageEvent::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSStorageEventConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

static inline JSC::EncodedJSValue jsStorageEventPrototypeFunctionInitStorageEventCaller(JSC::ExecState*, JSStorageEvent*, JSC::ThrowScope&);

EncodedJSValue JSC_HOST_CALL jsStorageEventPrototypeFunctionInitStorageEvent(ExecState* state)
{
    return BindingCaller<JSStorageEvent>::callOperation<jsStorageEventPrototypeFunctionInitStorageEventCaller>(state, "initStorageEvent");
}

static inline JSC::EncodedJSValue jsStorageEventPrototypeFunctionInitStorageEventCaller(JSC::ExecState* state, JSStorageEvent* castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    auto typeArg = convert<IDLDOMString>(*state, state->argument(0), StringConversionConfiguration::Normal);
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto canBubbleArg = convert<IDLBoolean>(*state, state->argument(1));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto cancelableArg = convert<IDLBoolean>(*state, state->argument(2));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto keyArg = convert<IDLDOMString>(*state, state->argument(3), StringConversionConfiguration::Normal);
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto oldValueArg = state->argument(4).isUndefined() ? String() : convert<IDLNullable<IDLDOMString>>(*state, state->uncheckedArgument(4), StringConversionConfiguration::Normal);
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto newValueArg = state->argument(5).isUndefined() ? String() : convert<IDLNullable<IDLDOMString>>(*state, state->uncheckedArgument(5), StringConversionConfiguration::Normal);
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto urlArg = convert<IDLUSVString>(*state, state->argument(6), StringConversionConfiguration::Normal);
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto storageAreaArg = convert<IDLNullable<IDLInterface<Storage>>>(*state, state->argument(7), [](JSC::ExecState& state, JSC::ThrowScope& scope) { throwArgumentTypeError(state, scope, 7, "storageAreaArg", "StorageEvent", "initStorageEvent", "Storage"); });
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    impl.initStorageEvent(WTFMove(typeArg), WTFMove(canBubbleArg), WTFMove(cancelableArg), WTFMove(keyArg), WTFMove(oldValueArg), WTFMove(newValueArg), WTFMove(urlArg), WTFMove(storageAreaArg));
    return JSValue::encode(jsUndefined());
}

#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7StorageEvent@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore12StorageEventE[]; }
#endif
#endif

JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject* globalObject, Ref<StorageEvent>&& impl)
{

#if ENABLE(BINDING_INTEGRITY)
    void* actualVTablePointer = *(reinterpret_cast<void**>(impl.ptr()));
#if PLATFORM(WIN)
    void* expectedVTablePointer = reinterpret_cast<void*>(__identifier("??_7StorageEvent@WebCore@@6B@"));
#else
    void* expectedVTablePointer = &_ZTVN7WebCore12StorageEventE[2];
#if COMPILER(CLANG)
    // If this fails StorageEvent does not have a vtable, so you need to add the
    // ImplementationLacksVTable attribute to the interface definition
    static_assert(__is_polymorphic(StorageEvent), "StorageEvent is not polymorphic");
#endif
#endif
    // If you hit this assertion you either have a use after free bug, or
    // StorageEvent has subclasses. If StorageEvent has subclasses that get passed
    // to toJS() we currently require StorageEvent you to opt out of binding hardening
    // by adding the SkipVTableValidation attribute to the interface IDL definition
    RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    return createWrapper<StorageEvent>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, StorageEvent& impl)
{
    return wrap(state, globalObject, impl);
}


}
