/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSTextEncoder.h"

#include "JSDOMBinding.h"
#include "JSDOMBindingCaller.h"
#include "JSDOMConstructor.h"
#include "JSDOMConvert.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMWrapperCache.h"
#include <runtime/Error.h>
#include <runtime/FunctionPrototype.h>
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

// Functions

JSC::EncodedJSValue JSC_HOST_CALL jsTextEncoderPrototypeFunctionEncode(JSC::ExecState*);

// Attributes

JSC::EncodedJSValue jsTextEncoderEncoding(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsTextEncoderConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSTextEncoderConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);

class JSTextEncoderPrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSTextEncoderPrototype* create(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSTextEncoderPrototype* ptr = new (NotNull, JSC::allocateCell<JSTextEncoderPrototype>(vm.heap)) JSTextEncoderPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSTextEncoderPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSTextEncoderConstructor = JSDOMConstructor<JSTextEncoder>;

template<> EncodedJSValue JSC_HOST_CALL JSTextEncoderConstructor::construct(ExecState* state)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    auto* castedThis = jsCast<JSTextEncoderConstructor*>(state->jsCallee());
    ASSERT(castedThis);
    auto object = TextEncoder::create();
    return JSValue::encode(toJSNewlyCreated<IDLInterface<TextEncoder>>(*state, *castedThis->globalObject(), WTFMove(object)));
}

template<> JSValue JSTextEncoderConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.functionPrototype();
}

template<> void JSTextEncoderConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSTextEncoder::prototype(vm, &globalObject), DontDelete | ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(&vm, String(ASCIILiteral("TextEncoder"))), ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), ReadOnly | DontEnum);
}

template<> const ClassInfo JSTextEncoderConstructor::s_info = { "TextEncoder", &Base::s_info, 0, CREATE_METHOD_TABLE(JSTextEncoderConstructor) };

/* Hash table for prototype */

static const HashTableValue JSTextEncoderPrototypeTableValues[] =
{
    { "constructor", DontEnum, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsTextEncoderConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSTextEncoderConstructor) } },
    { "encoding", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsTextEncoderEncoding), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "encode", JSC::Function, NoIntrinsic, { (intptr_t)static_cast<NativeFunction>(jsTextEncoderPrototypeFunctionEncode), (intptr_t) (0) } },
};

const ClassInfo JSTextEncoderPrototype::s_info = { "TextEncoderPrototype", &Base::s_info, 0, CREATE_METHOD_TABLE(JSTextEncoderPrototype) };

void JSTextEncoderPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSTextEncoderPrototypeTableValues, *this);
}

const ClassInfo JSTextEncoder::s_info = { "TextEncoder", &Base::s_info, 0, CREATE_METHOD_TABLE(JSTextEncoder) };

JSTextEncoder::JSTextEncoder(Structure* structure, JSDOMGlobalObject& globalObject, Ref<TextEncoder>&& impl)
    : JSDOMWrapper<TextEncoder>(structure, globalObject, WTFMove(impl))
{
}

void JSTextEncoder::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSTextEncoder::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSTextEncoderPrototype::create(vm, globalObject, JSTextEncoderPrototype::createStructure(vm, globalObject, globalObject->objectPrototype()));
}

JSObject* JSTextEncoder::prototype(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSTextEncoder>(vm, globalObject);
}

void JSTextEncoder::destroy(JSC::JSCell* cell)
{
    JSTextEncoder* thisObject = static_cast<JSTextEncoder*>(cell);
    thisObject->JSTextEncoder::~JSTextEncoder();
}

template<> inline JSTextEncoder* BindingCaller<JSTextEncoder>::castForAttribute(ExecState& state, EncodedJSValue thisValue)
{
    return jsDynamicDowncast<JSTextEncoder*>(state.vm(), JSValue::decode(thisValue));
}

template<> inline JSTextEncoder* BindingCaller<JSTextEncoder>::castForOperation(ExecState& state)
{
    return jsDynamicDowncast<JSTextEncoder*>(state.vm(), state.thisValue());
}

static inline JSValue jsTextEncoderEncodingGetter(ExecState&, JSTextEncoder&, ThrowScope& throwScope);

EncodedJSValue jsTextEncoderEncoding(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSTextEncoder>::attribute<jsTextEncoderEncodingGetter>(state, thisValue, "encoding");
}

static inline JSValue jsTextEncoderEncodingGetter(ExecState& state, JSTextEncoder& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLDOMString>(state, impl.encoding());
    return result;
}

EncodedJSValue jsTextEncoderConstructor(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    JSTextEncoderPrototype* domObject = jsDynamicDowncast<JSTextEncoderPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!domObject))
        return throwVMTypeError(state, throwScope);
    return JSValue::encode(JSTextEncoder::getConstructor(state->vm(), domObject->globalObject()));
}

bool setJSTextEncoderConstructor(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    JSValue value = JSValue::decode(encodedValue);
    JSTextEncoderPrototype* domObject = jsDynamicDowncast<JSTextEncoderPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!domObject)) {
        throwVMTypeError(state, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return domObject->putDirect(state->vm(), state->propertyNames().constructor, value);
}

JSValue JSTextEncoder::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSTextEncoderConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

static inline JSC::EncodedJSValue jsTextEncoderPrototypeFunctionEncodeCaller(JSC::ExecState*, JSTextEncoder*, JSC::ThrowScope&);

EncodedJSValue JSC_HOST_CALL jsTextEncoderPrototypeFunctionEncode(ExecState* state)
{
    return BindingCaller<JSTextEncoder>::callOperation<jsTextEncoderPrototypeFunctionEncodeCaller>(state, "encode");
}

static inline JSC::EncodedJSValue jsTextEncoderPrototypeFunctionEncodeCaller(JSC::ExecState* state, JSTextEncoder* castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    auto input = state->argument(0).isUndefined() ? emptyString() : convert<IDLUSVString>(*state, state->uncheckedArgument(0), StringConversionConfiguration::Normal);
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    return JSValue::encode(toJS<IDLInterface<Uint8Array>>(*state, *castedThis->globalObject(), impl.encode(WTFMove(input))));
}

bool JSTextEncoderOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    return false;
}

void JSTextEncoderOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsTextEncoder = static_cast<JSTextEncoder*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsTextEncoder->wrapped(), jsTextEncoder);
}

JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject* globalObject, Ref<TextEncoder>&& impl)
{
#if COMPILER(CLANG)
    // If you hit this failure the interface definition has the ImplementationLacksVTable
    // attribute. You should remove that attribute. If the class has subclasses
    // that may be passed through this toJS() function you should use the SkipVTableValidation
    // attribute to TextEncoder.
    static_assert(!__is_polymorphic(TextEncoder), "TextEncoder is polymorphic but the IDL claims it is not");
#endif
    return createWrapper<TextEncoder>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, TextEncoder& impl)
{
    return wrap(state, globalObject, impl);
}

TextEncoder* JSTextEncoder::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicDowncast<JSTextEncoder*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}
