/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(USER_MESSAGE_HANDLERS)

#include "JSWebKitNamespace.h"

#include "JSDOMBinding.h"
#include "JSDOMBindingCaller.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMConvert.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMWrapperCache.h"
#include "JSUserMessageHandlersNamespace.h"
#include <runtime/FunctionPrototype.h>
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

// Attributes

JSC::EncodedJSValue jsWebKitNamespaceMessageHandlers(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsWebKitNamespaceConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSWebKitNamespaceConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);

class JSWebKitNamespacePrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSWebKitNamespacePrototype* create(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSWebKitNamespacePrototype* ptr = new (NotNull, JSC::allocateCell<JSWebKitNamespacePrototype>(vm.heap)) JSWebKitNamespacePrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSWebKitNamespacePrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSWebKitNamespaceConstructor = JSDOMConstructorNotConstructable<JSWebKitNamespace>;

template<> JSValue JSWebKitNamespaceConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.functionPrototype();
}

template<> void JSWebKitNamespaceConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSWebKitNamespace::prototype(vm, &globalObject), DontDelete | ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(&vm, String(ASCIILiteral("WebKitNamespace"))), ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), ReadOnly | DontEnum);
}

template<> const ClassInfo JSWebKitNamespaceConstructor::s_info = { "WebKitNamespace", &Base::s_info, 0, CREATE_METHOD_TABLE(JSWebKitNamespaceConstructor) };

/* Hash table for prototype */

static const HashTableValue JSWebKitNamespacePrototypeTableValues[] =
{
    { "constructor", DontEnum, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsWebKitNamespaceConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSWebKitNamespaceConstructor) } },
    { "messageHandlers", ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsWebKitNamespaceMessageHandlers), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
};

const ClassInfo JSWebKitNamespacePrototype::s_info = { "WebKitNamespacePrototype", &Base::s_info, 0, CREATE_METHOD_TABLE(JSWebKitNamespacePrototype) };

void JSWebKitNamespacePrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSWebKitNamespacePrototypeTableValues, *this);
}

const ClassInfo JSWebKitNamespace::s_info = { "WebKitNamespace", &Base::s_info, 0, CREATE_METHOD_TABLE(JSWebKitNamespace) };

JSWebKitNamespace::JSWebKitNamespace(Structure* structure, JSDOMGlobalObject& globalObject, Ref<WebKitNamespace>&& impl)
    : JSDOMWrapper<WebKitNamespace>(structure, globalObject, WTFMove(impl))
{
}

void JSWebKitNamespace::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSWebKitNamespace::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSWebKitNamespacePrototype::create(vm, globalObject, JSWebKitNamespacePrototype::createStructure(vm, globalObject, globalObject->objectPrototype()));
}

JSObject* JSWebKitNamespace::prototype(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSWebKitNamespace>(vm, globalObject);
}

void JSWebKitNamespace::destroy(JSC::JSCell* cell)
{
    JSWebKitNamespace* thisObject = static_cast<JSWebKitNamespace*>(cell);
    thisObject->JSWebKitNamespace::~JSWebKitNamespace();
}

template<> inline JSWebKitNamespace* BindingCaller<JSWebKitNamespace>::castForAttribute(ExecState& state, EncodedJSValue thisValue)
{
    return jsDynamicDowncast<JSWebKitNamespace*>(state.vm(), JSValue::decode(thisValue));
}

static inline JSValue jsWebKitNamespaceMessageHandlersGetter(ExecState&, JSWebKitNamespace&, ThrowScope& throwScope);

EncodedJSValue jsWebKitNamespaceMessageHandlers(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return BindingCaller<JSWebKitNamespace>::attribute<jsWebKitNamespaceMessageHandlersGetter>(state, thisValue, "messageHandlers");
}

static inline JSValue jsWebKitNamespaceMessageHandlersGetter(ExecState& state, JSWebKitNamespace& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLInterface<UserMessageHandlersNamespace>>(state, *thisObject.globalObject(), impl.messageHandlers());
    return result;
}

EncodedJSValue jsWebKitNamespaceConstructor(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    JSWebKitNamespacePrototype* domObject = jsDynamicDowncast<JSWebKitNamespacePrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!domObject))
        return throwVMTypeError(state, throwScope);
    return JSValue::encode(JSWebKitNamespace::getConstructor(state->vm(), domObject->globalObject()));
}

bool setJSWebKitNamespaceConstructor(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    JSValue value = JSValue::decode(encodedValue);
    JSWebKitNamespacePrototype* domObject = jsDynamicDowncast<JSWebKitNamespacePrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!domObject)) {
        throwVMTypeError(state, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return domObject->putDirect(state->vm(), state->propertyNames().constructor, value);
}

JSValue JSWebKitNamespace::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSWebKitNamespaceConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

bool JSWebKitNamespaceOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    return false;
}

void JSWebKitNamespaceOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsWebKitNamespace = static_cast<JSWebKitNamespace*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsWebKitNamespace->wrapped(), jsWebKitNamespace);
}

#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7WebKitNamespace@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore15WebKitNamespaceE[]; }
#endif
#endif

JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject* globalObject, Ref<WebKitNamespace>&& impl)
{

#if ENABLE(BINDING_INTEGRITY)
    void* actualVTablePointer = *(reinterpret_cast<void**>(impl.ptr()));
#if PLATFORM(WIN)
    void* expectedVTablePointer = reinterpret_cast<void*>(__identifier("??_7WebKitNamespace@WebCore@@6B@"));
#else
    void* expectedVTablePointer = &_ZTVN7WebCore15WebKitNamespaceE[2];
#if COMPILER(CLANG)
    // If this fails WebKitNamespace does not have a vtable, so you need to add the
    // ImplementationLacksVTable attribute to the interface definition
    static_assert(__is_polymorphic(WebKitNamespace), "WebKitNamespace is not polymorphic");
#endif
#endif
    // If you hit this assertion you either have a use after free bug, or
    // WebKitNamespace has subclasses. If WebKitNamespace has subclasses that get passed
    // to toJS() we currently require WebKitNamespace you to opt out of binding hardening
    // by adding the SkipVTableValidation attribute to the interface IDL definition
    RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    return createWrapper<WebKitNamespace>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, WebKitNamespace& impl)
{
    return wrap(state, globalObject, impl);
}

WebKitNamespace* JSWebKitNamespace::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicDowncast<JSWebKitNamespace*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}

#endif // ENABLE(USER_MESSAGE_HANDLERS)
